/* adaptative-window.c generated by valac 0.56.17, the Vala compiler
 * generated from adaptative-window.vala, do not modify */

/*
  This file is part of Dconf Editor

  Dconf Editor is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  Dconf Editor is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Dconf Editor.  If not, see <https://www.gnu.org/licenses/>.
*/

#include <glib-object.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <gdk/gdk.h>
#include <cairo-gobject.h>
#include <stdlib.h>
#include <string.h>

#define LARGE_WINDOW_SIZE 1042
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_ADAPTATIVE_WIDGET (adaptative_widget_get_type ())
#define ADAPTATIVE_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ADAPTATIVE_WIDGET, AdaptativeWidget))
#define IS_ADAPTATIVE_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ADAPTATIVE_WIDGET))
#define ADAPTATIVE_WIDGET_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_ADAPTATIVE_WIDGET, AdaptativeWidgetIface))

typedef struct _AdaptativeWidget AdaptativeWidget;
typedef struct _AdaptativeWidgetIface AdaptativeWidgetIface;
typedef enum  {
	ADAPTATIVE_WIDGET_WINDOW_SIZE_START_SIZE,
	ADAPTATIVE_WIDGET_WINDOW_SIZE_USUAL_SIZE,
	ADAPTATIVE_WIDGET_WINDOW_SIZE_QUITE_THIN,
	ADAPTATIVE_WIDGET_WINDOW_SIZE_PHONE_VERT,
	ADAPTATIVE_WIDGET_WINDOW_SIZE_PHONE_HZTL,
	ADAPTATIVE_WIDGET_WINDOW_SIZE_PHONE_BOTH,
	ADAPTATIVE_WIDGET_WINDOW_SIZE_EXTRA_THIN,
	ADAPTATIVE_WIDGET_WINDOW_SIZE_EXTRA_FLAT
} AdaptativeWidgetWindowSize;

#define ADAPTATIVE_WIDGET_TYPE_WINDOW_SIZE (adaptative_widget_window_size_get_type ())

#define TYPE_ADAPTATIVE_WINDOW (adaptative_window_get_type ())
#define ADAPTATIVE_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ADAPTATIVE_WINDOW, AdaptativeWindow))
#define ADAPTATIVE_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ADAPTATIVE_WINDOW, AdaptativeWindowClass))
#define IS_ADAPTATIVE_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ADAPTATIVE_WINDOW))
#define IS_ADAPTATIVE_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ADAPTATIVE_WINDOW))
#define ADAPTATIVE_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ADAPTATIVE_WINDOW, AdaptativeWindowClass))

typedef struct _AdaptativeWindow AdaptativeWindow;
typedef struct _AdaptativeWindowClass AdaptativeWindowClass;
typedef struct _AdaptativeWindowPrivate AdaptativeWindowPrivate;

#define TYPE_BASE_HEADER_BAR (base_header_bar_get_type ())
#define BASE_HEADER_BAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BASE_HEADER_BAR, BaseHeaderBar))
#define BASE_HEADER_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BASE_HEADER_BAR, BaseHeaderBarClass))
#define IS_BASE_HEADER_BAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BASE_HEADER_BAR))
#define IS_BASE_HEADER_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BASE_HEADER_BAR))
#define BASE_HEADER_BAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BASE_HEADER_BAR, BaseHeaderBarClass))

typedef struct _BaseHeaderBar BaseHeaderBar;
typedef struct _BaseHeaderBarClass BaseHeaderBarClass;
enum  {
	ADAPTATIVE_WINDOW_0_PROPERTY,
	ADAPTATIVE_WINDOW_NTA_HEADERBAR_PROPERTY,
	ADAPTATIVE_WINDOW_WINDOW_TITLE_PROPERTY,
	ADAPTATIVE_WINDOW_SPECIFIC_CSS_CLASS_OR_EMPTY_PROPERTY,
	ADAPTATIVE_WINDOW_SCHEMA_PATH_PROPERTY,
	ADAPTATIVE_WINDOW_NUM_PROPERTIES
};
static GParamSpec* adaptative_window_properties[ADAPTATIVE_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block1Data Block1Data;
#define _g_free0(var) ((var == NULL) ? NULL : (var = (g_free (var), NULL)))
enum  {
	ADAPTATIVE_WINDOW_GTK_THEME_CHANGED_SIGNAL,
	ADAPTATIVE_WINDOW_NUM_SIGNALS
};
static guint adaptative_window_signals[ADAPTATIVE_WINDOW_NUM_SIGNALS] = {0};

struct _AdaptativeWidgetIface {
	GTypeInterface parent_iface;
	void (*set_window_size) (AdaptativeWidget* self, AdaptativeWidgetWindowSize new_size);
};

struct _AdaptativeWindow {
	GtkApplicationWindow parent_instance;
	AdaptativeWindowPrivate * priv;
};

struct _AdaptativeWindowClass {
	GtkApplicationWindowClass parent_class;
	void (*before_destroy) (AdaptativeWindow* self);
};

struct _AdaptativeWindowPrivate {
	BaseHeaderBar* headerbar;
	GtkStyleContext* window_style_context;
	AdaptativeWidgetWindowSize window_size;
	GList* adaptative_children;
	gboolean has_extra_thin_window_class;
	gboolean has_thin_window_class;
	gboolean has_large_window_class;
	gboolean has_extra_flat_window_class;
	gboolean has_flat_window_class;
	GSettings* settings;
	gint window_width;
	gint window_height;
	gboolean window_is_maximized;
	gboolean window_is_tiled;
	gboolean highcontrast_state;
};

struct _Block1Data {
	int _ref_count_;
	AdaptativeWindow* self;
	AdaptativeWidgetWindowSize new_window_size;
};

static gint AdaptativeWindow_private_offset;
static gpointer adaptative_window_parent_class = NULL;

VALA_EXTERN GType adaptative_widget_window_size_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType adaptative_widget_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AdaptativeWidget, g_object_unref)
VALA_EXTERN gboolean adaptative_widget_window_size_is_phone_size (AdaptativeWidgetWindowSize window_size);
VALA_EXTERN gboolean adaptative_widget_window_size_is_extra_thin (AdaptativeWidgetWindowSize window_size);
VALA_EXTERN gboolean adaptative_widget_window_size_is_extra_flat (AdaptativeWidgetWindowSize window_size);
VALA_EXTERN gboolean adaptative_widget_window_size_is_quite_thin (AdaptativeWidgetWindowSize window_size);
VALA_EXTERN void adaptative_widget_set_window_size (AdaptativeWidget* self,
                                        AdaptativeWidgetWindowSize new_size);
static GType adaptative_widget_get_type_once (void);
VALA_EXTERN GType adaptative_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AdaptativeWindow, g_object_unref)
VALA_EXTERN GType base_header_bar_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (BaseHeaderBar, g_object_unref)
VALA_EXTERN void adaptative_window_before_destroy (AdaptativeWindow* self);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static gboolean adaptative_window_on_window_state_event (AdaptativeWindow* self,
                                                  GtkWidget* widget,
                                                  GdkEventWindowState* event);
static gboolean _adaptative_window_on_window_state_event_gtk_widget_window_state_event (GtkWidget* _sender,
                                                                                 GdkEventWindowState* event,
                                                                                 gpointer self);
static void adaptative_window_on_size_allocate (AdaptativeWindow* self,
                                         GtkAllocation* allocation);
static void adaptative_window_update_adaptative_children (AdaptativeWindow* self,
                                                   gint* width,
                                                   gint* height);
static void adaptative_window_update_window_state (AdaptativeWindow* self);
static void _adaptative_window_on_size_allocate_gtk_widget_size_allocate (GtkWidget* _sender,
                                                                   GtkAllocation* allocation,
                                                                   gpointer self);
static void adaptative_window_on_destroy (AdaptativeWindow* self);
static void adaptative_window_save_window_state (AdaptativeWindow* self);
static void _adaptative_window_on_destroy_gtk_widget_destroy (GtkWidget* _sender,
                                                       gpointer self);
static void adaptative_window_real_before_destroy (AdaptativeWindow* self);
VALA_EXTERN void adaptative_window_add_adaptative_child (AdaptativeWindow* self,
                                             AdaptativeWidget* child);
static void adaptative_window_change_window_size (AdaptativeWindow* self,
                                           AdaptativeWidgetWindowSize new_window_size);
static void adaptative_window_set_style_classes (AdaptativeWindow* self,
                                          gboolean extra_thin_window,
                                          gboolean thin_window,
                                          gboolean large_window,
                                          gboolean extra_flat_window,
                                          gboolean flat_window);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void __lambda5_ (Block1Data* _data1_,
                 AdaptativeWidget* adaptative_child);
static void ___lambda5__gfunc (gconstpointer data,
                        gpointer self);
static inline void adaptative_window_set_style_class (AdaptativeWindow* self,
                                        const gchar* class_name,
                                        gboolean new_state,
                                        gboolean* old_state);
static void adaptative_window_load_window_state (AdaptativeWindow* self);
static gint* _int_dup (gint* self);
static void adaptative_window_manage_high_contrast (AdaptativeWindow* self);
static void adaptative_window_update_highcontrast_state (AdaptativeWindow* self,
                                                  GObject* gtk_settings,
                                                  GParamSpec* unused);
static void _adaptative_window_update_highcontrast_state_g_object_notify (GObject* _sender,
                                                                   GParamSpec* pspec,
                                                                   gpointer self);
static void _adaptative_window_update_highcontrast_state (AdaptativeWindow* self,
                                                   const gchar* theme_name);
VALA_EXTERN void base_header_bar_update_hamburger_menu (BaseHeaderBar* self);
VALA_EXTERN AdaptativeWindow* adaptative_window_construct (GType object_type);
VALA_EXTERN BaseHeaderBar* adaptative_window_get_nta_headerbar (AdaptativeWindow* self);
static void adaptative_window_set_nta_headerbar (AdaptativeWindow* self,
                                          BaseHeaderBar* value);
static void adaptative_window_set_window_title (AdaptativeWindow* self,
                                         const gchar* value);
static void adaptative_window_set_specific_css_class_or_empty (AdaptativeWindow* self,
                                                        const gchar* value);
static void adaptative_window_set_schema_path (AdaptativeWindow* self,
                                        const gchar* value);
static GObject * adaptative_window_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties);
static gboolean _adaptative_window___lambda6_ (AdaptativeWindow* self);
static gboolean __adaptative_window___lambda6__gsource_func (gpointer self);
static void adaptative_window_finalize (GObject * obj);
static GType adaptative_window_get_type_once (void);
static void _vala_adaptative_window_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
static void _vala_adaptative_window_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec);

inline gboolean
adaptative_widget_window_size_is_phone_size (AdaptativeWidgetWindowSize window_size)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean result;
#line 49 "../editor/adaptative-window.vala"
	if (window_size == ADAPTATIVE_WIDGET_WINDOW_SIZE_PHONE_BOTH) {
#line 49 "../editor/adaptative-window.vala"
		_tmp1_ = TRUE;
#line 255 "adaptative-window.c"
	} else {
#line 49 "../editor/adaptative-window.vala"
		_tmp1_ = window_size == ADAPTATIVE_WIDGET_WINDOW_SIZE_PHONE_VERT;
#line 259 "adaptative-window.c"
	}
#line 49 "../editor/adaptative-window.vala"
	if (_tmp1_) {
#line 49 "../editor/adaptative-window.vala"
		_tmp0_ = TRUE;
#line 265 "adaptative-window.c"
	} else {
#line 49 "../editor/adaptative-window.vala"
		_tmp0_ = window_size == ADAPTATIVE_WIDGET_WINDOW_SIZE_PHONE_HZTL;
#line 269 "adaptative-window.c"
	}
#line 49 "../editor/adaptative-window.vala"
	result = _tmp0_;
#line 49 "../editor/adaptative-window.vala"
	return result;
#line 275 "adaptative-window.c"
}

inline gboolean
adaptative_widget_window_size_is_extra_thin (AdaptativeWidgetWindowSize window_size)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean result;
#line 54 "../editor/adaptative-window.vala"
	if (window_size == ADAPTATIVE_WIDGET_WINDOW_SIZE_PHONE_BOTH) {
#line 54 "../editor/adaptative-window.vala"
		_tmp1_ = TRUE;
#line 288 "adaptative-window.c"
	} else {
#line 54 "../editor/adaptative-window.vala"
		_tmp1_ = window_size == ADAPTATIVE_WIDGET_WINDOW_SIZE_PHONE_VERT;
#line 292 "adaptative-window.c"
	}
#line 54 "../editor/adaptative-window.vala"
	if (_tmp1_) {
#line 54 "../editor/adaptative-window.vala"
		_tmp0_ = TRUE;
#line 298 "adaptative-window.c"
	} else {
#line 54 "../editor/adaptative-window.vala"
		_tmp0_ = window_size == ADAPTATIVE_WIDGET_WINDOW_SIZE_EXTRA_THIN;
#line 302 "adaptative-window.c"
	}
#line 54 "../editor/adaptative-window.vala"
	result = _tmp0_;
#line 54 "../editor/adaptative-window.vala"
	return result;
#line 308 "adaptative-window.c"
}

inline gboolean
adaptative_widget_window_size_is_extra_flat (AdaptativeWidgetWindowSize window_size)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean result;
#line 59 "../editor/adaptative-window.vala"
	if (window_size == ADAPTATIVE_WIDGET_WINDOW_SIZE_PHONE_BOTH) {
#line 59 "../editor/adaptative-window.vala"
		_tmp1_ = TRUE;
#line 321 "adaptative-window.c"
	} else {
#line 59 "../editor/adaptative-window.vala"
		_tmp1_ = window_size == ADAPTATIVE_WIDGET_WINDOW_SIZE_PHONE_HZTL;
#line 325 "adaptative-window.c"
	}
#line 59 "../editor/adaptative-window.vala"
	if (_tmp1_) {
#line 59 "../editor/adaptative-window.vala"
		_tmp0_ = TRUE;
#line 331 "adaptative-window.c"
	} else {
#line 59 "../editor/adaptative-window.vala"
		_tmp0_ = window_size == ADAPTATIVE_WIDGET_WINDOW_SIZE_EXTRA_FLAT;
#line 335 "adaptative-window.c"
	}
#line 59 "../editor/adaptative-window.vala"
	result = _tmp0_;
#line 59 "../editor/adaptative-window.vala"
	return result;
#line 341 "adaptative-window.c"
}

inline gboolean
adaptative_widget_window_size_is_quite_thin (AdaptativeWidgetWindowSize window_size)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean result;
#line 64 "../editor/adaptative-window.vala"
	if (adaptative_widget_window_size_is_extra_thin (window_size)) {
#line 64 "../editor/adaptative-window.vala"
		_tmp1_ = TRUE;
#line 354 "adaptative-window.c"
	} else {
#line 64 "../editor/adaptative-window.vala"
		_tmp1_ = window_size == ADAPTATIVE_WIDGET_WINDOW_SIZE_PHONE_HZTL;
#line 358 "adaptative-window.c"
	}
#line 64 "../editor/adaptative-window.vala"
	if (_tmp1_) {
#line 64 "../editor/adaptative-window.vala"
		_tmp0_ = TRUE;
#line 364 "adaptative-window.c"
	} else {
#line 64 "../editor/adaptative-window.vala"
		_tmp0_ = window_size == ADAPTATIVE_WIDGET_WINDOW_SIZE_QUITE_THIN;
#line 368 "adaptative-window.c"
	}
#line 64 "../editor/adaptative-window.vala"
	result = _tmp0_;
#line 64 "../editor/adaptative-window.vala"
	return result;
#line 374 "adaptative-window.c"
}

static GType
adaptative_widget_window_size_get_type_once (void)
{
	static const GEnumValue values[] = {{ADAPTATIVE_WIDGET_WINDOW_SIZE_START_SIZE, "ADAPTATIVE_WIDGET_WINDOW_SIZE_START_SIZE", "start-size"}, {ADAPTATIVE_WIDGET_WINDOW_SIZE_USUAL_SIZE, "ADAPTATIVE_WIDGET_WINDOW_SIZE_USUAL_SIZE", "usual-size"}, {ADAPTATIVE_WIDGET_WINDOW_SIZE_QUITE_THIN, "ADAPTATIVE_WIDGET_WINDOW_SIZE_QUITE_THIN", "quite-thin"}, {ADAPTATIVE_WIDGET_WINDOW_SIZE_PHONE_VERT, "ADAPTATIVE_WIDGET_WINDOW_SIZE_PHONE_VERT", "phone-vert"}, {ADAPTATIVE_WIDGET_WINDOW_SIZE_PHONE_HZTL, "ADAPTATIVE_WIDGET_WINDOW_SIZE_PHONE_HZTL", "phone-hztl"}, {ADAPTATIVE_WIDGET_WINDOW_SIZE_PHONE_BOTH, "ADAPTATIVE_WIDGET_WINDOW_SIZE_PHONE_BOTH", "phone-both"}, {ADAPTATIVE_WIDGET_WINDOW_SIZE_EXTRA_THIN, "ADAPTATIVE_WIDGET_WINDOW_SIZE_EXTRA_THIN", "extra-thin"}, {ADAPTATIVE_WIDGET_WINDOW_SIZE_EXTRA_FLAT, "ADAPTATIVE_WIDGET_WINDOW_SIZE_EXTRA_FLAT", "extra-flat"}, {0, NULL, NULL}};
	GType adaptative_widget_window_size_type_id;
	adaptative_widget_window_size_type_id = g_enum_register_static ("AdaptativeWidgetWindowSize", values);
	return adaptative_widget_window_size_type_id;
}

GType
adaptative_widget_window_size_get_type (void)
{
	static volatile gsize adaptative_widget_window_size_type_id__once = 0;
	if (g_once_init_enter (&adaptative_widget_window_size_type_id__once)) {
		GType adaptative_widget_window_size_type_id;
		adaptative_widget_window_size_type_id = adaptative_widget_window_size_get_type_once ();
		g_once_init_leave (&adaptative_widget_window_size_type_id__once, adaptative_widget_window_size_type_id);
	}
	return adaptative_widget_window_size_type_id__once;
}

void
adaptative_widget_set_window_size (AdaptativeWidget* self,
                                   AdaptativeWidgetWindowSize new_size)
{
	AdaptativeWidgetIface* _iface_;
#line 68 "../editor/adaptative-window.vala"
	g_return_if_fail (self != NULL);
#line 68 "../editor/adaptative-window.vala"
	_iface_ = ADAPTATIVE_WIDGET_GET_INTERFACE (self);
#line 68 "../editor/adaptative-window.vala"
	if (_iface_->set_window_size) {
#line 68 "../editor/adaptative-window.vala"
		_iface_->set_window_size (self, new_size);
#line 411 "adaptative-window.c"
	}
}

static void
adaptative_widget_default_init (AdaptativeWidgetIface * iface,
                                gpointer iface_data)
{
}

static GType
adaptative_widget_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (AdaptativeWidgetIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) adaptative_widget_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType adaptative_widget_type_id;
	adaptative_widget_type_id = g_type_register_static (G_TYPE_INTERFACE, "AdaptativeWidget", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (adaptative_widget_type_id, G_TYPE_OBJECT);
	return adaptative_widget_type_id;
}

GType
adaptative_widget_get_type (void)
{
	static volatile gsize adaptative_widget_type_id__once = 0;
	if (g_once_init_enter (&adaptative_widget_type_id__once)) {
		GType adaptative_widget_type_id;
		adaptative_widget_type_id = adaptative_widget_get_type_once ();
		g_once_init_leave (&adaptative_widget_type_id__once, adaptative_widget_type_id);
	}
	return adaptative_widget_type_id__once;
}

static inline gpointer
adaptative_window_get_instance_private (AdaptativeWindow* self)
{
	return G_STRUCT_MEMBER_P (self, AdaptativeWindow_private_offset);
}

static void
_g_object_unref0_ (gpointer var)
{
#line 179 "../editor/adaptative-window.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 454 "adaptative-window.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 179 "../editor/adaptative-window.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 462 "adaptative-window.c"
}

static gboolean
adaptative_window_on_window_state_event (AdaptativeWindow* self,
                                         GtkWidget* widget,
                                         GdkEventWindowState* event)
{
	GdkWindowState tiled_state = 0U;
	gboolean result;
#line 136 "../editor/adaptative-window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 136 "../editor/adaptative-window.vala"
	g_return_val_if_fail (widget != NULL, FALSE);
#line 136 "../editor/adaptative-window.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 138 "../editor/adaptative-window.vala"
	if ((event->changed_mask & GDK_WINDOW_STATE_MAXIMIZED) != 0) {
#line 139 "../editor/adaptative-window.vala"
		self->priv->window_is_maximized = (event->new_window_state & GDK_WINDOW_STATE_MAXIMIZED) != 0;
#line 482 "adaptative-window.c"
	}
#line 142 "../editor/adaptative-window.vala"
	tiled_state = (((GDK_WINDOW_STATE_TILED | GDK_WINDOW_STATE_TOP_TILED) | GDK_WINDOW_STATE_BOTTOM_TILED) | GDK_WINDOW_STATE_LEFT_TILED) | GDK_WINDOW_STATE_RIGHT_TILED;
#line 147 "../editor/adaptative-window.vala"
	if ((event->changed_mask & tiled_state) != 0) {
#line 148 "../editor/adaptative-window.vala"
		self->priv->window_is_tiled = (event->new_window_state & tiled_state) != 0;
#line 490 "adaptative-window.c"
	}
#line 150 "../editor/adaptative-window.vala"
	result = FALSE;
#line 150 "../editor/adaptative-window.vala"
	return result;
#line 496 "adaptative-window.c"
}

static gboolean
_adaptative_window_on_window_state_event_gtk_widget_window_state_event (GtkWidget* _sender,
                                                                        GdkEventWindowState* event,
                                                                        gpointer self)
{
	gboolean result;
	result = adaptative_window_on_window_state_event ((AdaptativeWindow*) self, _sender, event);
#line 74 "../editor/adaptative-window.vala"
	return result;
#line 508 "adaptative-window.c"
}

static void
adaptative_window_on_size_allocate (AdaptativeWindow* self,
                                    GtkAllocation* allocation)
{
	gint height = 0;
	GtkAllocation _tmp0_;
	gint width = 0;
	GtkAllocation _tmp1_;
#line 154 "../editor/adaptative-window.vala"
	g_return_if_fail (self != NULL);
#line 154 "../editor/adaptative-window.vala"
	g_return_if_fail (allocation != NULL);
#line 156 "../editor/adaptative-window.vala"
	_tmp0_ = *allocation;
#line 156 "../editor/adaptative-window.vala"
	height = _tmp0_.height;
#line 157 "../editor/adaptative-window.vala"
	_tmp1_ = *allocation;
#line 157 "../editor/adaptative-window.vala"
	width = _tmp1_.width;
#line 159 "../editor/adaptative-window.vala"
	adaptative_window_update_adaptative_children (self, &width, &height);
#line 160 "../editor/adaptative-window.vala"
	adaptative_window_update_window_state (self);
#line 535 "adaptative-window.c"
}

static void
_adaptative_window_on_size_allocate_gtk_widget_size_allocate (GtkWidget* _sender,
                                                              GtkAllocation* allocation,
                                                              gpointer self)
{
#line 74 "../editor/adaptative-window.vala"
	adaptative_window_on_size_allocate ((AdaptativeWindow*) self, allocation);
#line 545 "adaptative-window.c"
}

static void
adaptative_window_on_destroy (AdaptativeWindow* self)
{
#line 164 "../editor/adaptative-window.vala"
	g_return_if_fail (self != NULL);
#line 166 "../editor/adaptative-window.vala"
	adaptative_window_before_destroy (self);
#line 167 "../editor/adaptative-window.vala"
	adaptative_window_save_window_state (self);
#line 168 "../editor/adaptative-window.vala"
	GTK_WIDGET_CLASS (adaptative_window_parent_class)->destroy ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_application_window_get_type (), GtkApplicationWindow));
#line 559 "adaptative-window.c"
}

static void
_adaptative_window_on_destroy_gtk_widget_destroy (GtkWidget* _sender,
                                                  gpointer self)
{
#line 74 "../editor/adaptative-window.vala"
	adaptative_window_on_destroy ((AdaptativeWindow*) self);
#line 568 "adaptative-window.c"
}

static void
adaptative_window_real_before_destroy (AdaptativeWindow* self)
{
}

void
adaptative_window_before_destroy (AdaptativeWindow* self)
{
	AdaptativeWindowClass* _klass_;
#line 171 "../editor/adaptative-window.vala"
	g_return_if_fail (self != NULL);
#line 171 "../editor/adaptative-window.vala"
	_klass_ = ADAPTATIVE_WINDOW_GET_CLASS (self);
#line 171 "../editor/adaptative-window.vala"
	if (_klass_->before_destroy) {
#line 171 "../editor/adaptative-window.vala"
		_klass_->before_destroy (self);
#line 588 "adaptative-window.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 182 "../editor/adaptative-window.vala"
	return self ? g_object_ref (self) : NULL;
#line 597 "adaptative-window.c"
}

void
adaptative_window_add_adaptative_child (AdaptativeWindow* self,
                                        AdaptativeWidget* child)
{
	AdaptativeWidget* _tmp0_;
#line 180 "../editor/adaptative-window.vala"
	g_return_if_fail (self != NULL);
#line 180 "../editor/adaptative-window.vala"
	g_return_if_fail (child != NULL);
#line 182 "../editor/adaptative-window.vala"
	_tmp0_ = _g_object_ref0 (child);
#line 182 "../editor/adaptative-window.vala"
	self->priv->adaptative_children = g_list_append (self->priv->adaptative_children, _tmp0_);
#line 613 "adaptative-window.c"
}

static void
adaptative_window_update_adaptative_children (AdaptativeWindow* self,
                                              gint* width,
                                              gint* height)
{
	gboolean extra_flat = FALSE;
	gboolean flat = FALSE;
#line 185 "../editor/adaptative-window.vala"
	g_return_if_fail (self != NULL);
#line 187 "../editor/adaptative-window.vala"
	extra_flat = (*height) < 400;
#line 188 "../editor/adaptative-window.vala"
	flat = (*height) < 500;
#line 190 "../editor/adaptative-window.vala"
	if ((*width) < 590) {
#line 192 "../editor/adaptative-window.vala"
		if (extra_flat) {
#line 192 "../editor/adaptative-window.vala"
			adaptative_window_change_window_size (self, ADAPTATIVE_WIDGET_WINDOW_SIZE_PHONE_BOTH);
#line 635 "adaptative-window.c"
		} else {
#line 193 "../editor/adaptative-window.vala"
			if ((*height) < 787) {
#line 193 "../editor/adaptative-window.vala"
				adaptative_window_change_window_size (self, ADAPTATIVE_WIDGET_WINDOW_SIZE_PHONE_VERT);
#line 641 "adaptative-window.c"
			} else {
#line 194 "../editor/adaptative-window.vala"
				adaptative_window_change_window_size (self, ADAPTATIVE_WIDGET_WINDOW_SIZE_EXTRA_THIN);
#line 645 "adaptative-window.c"
			}
		}
#line 196 "../editor/adaptative-window.vala"
		adaptative_window_set_style_classes (self, TRUE, TRUE, FALSE, extra_flat, flat);
#line 650 "adaptative-window.c"
	} else {
#line 199 "../editor/adaptative-window.vala"
		if ((*width) < 787) {
#line 201 "../editor/adaptative-window.vala"
			if (extra_flat) {
#line 201 "../editor/adaptative-window.vala"
				adaptative_window_change_window_size (self, ADAPTATIVE_WIDGET_WINDOW_SIZE_PHONE_HZTL);
#line 658 "adaptative-window.c"
			} else {
#line 202 "../editor/adaptative-window.vala"
				adaptative_window_change_window_size (self, ADAPTATIVE_WIDGET_WINDOW_SIZE_QUITE_THIN);
#line 662 "adaptative-window.c"
			}
#line 204 "../editor/adaptative-window.vala"
			adaptative_window_set_style_classes (self, FALSE, TRUE, FALSE, extra_flat, flat);
#line 666 "adaptative-window.c"
		} else {
#line 209 "../editor/adaptative-window.vala"
			if (extra_flat) {
#line 209 "../editor/adaptative-window.vala"
				adaptative_window_change_window_size (self, ADAPTATIVE_WIDGET_WINDOW_SIZE_EXTRA_FLAT);
#line 672 "adaptative-window.c"
			} else {
#line 210 "../editor/adaptative-window.vala"
				adaptative_window_change_window_size (self, ADAPTATIVE_WIDGET_WINDOW_SIZE_USUAL_SIZE);
#line 676 "adaptative-window.c"
			}
#line 212 "../editor/adaptative-window.vala"
			adaptative_window_set_style_classes (self, FALSE, FALSE, (*width) > LARGE_WINDOW_SIZE, extra_flat, flat);
#line 680 "adaptative-window.c"
		}
	}
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 217 "../editor/adaptative-window.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 217 "../editor/adaptative-window.vala"
	return _data1_;
#line 692 "adaptative-window.c"
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 217 "../editor/adaptative-window.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 702 "adaptative-window.c"
		AdaptativeWindow* self;
#line 217 "../editor/adaptative-window.vala"
		self = _data1_->self;
#line 217 "../editor/adaptative-window.vala"
		_g_object_unref0 (self);
#line 217 "../editor/adaptative-window.vala"
		g_slice_free (Block1Data, _data1_);
#line 710 "adaptative-window.c"
	}
}

static void
__lambda5_ (Block1Data* _data1_,
            AdaptativeWidget* adaptative_child)
{
	AdaptativeWindow* self;
#line 222 "../editor/adaptative-window.vala"
	self = _data1_->self;
#line 222 "../editor/adaptative-window.vala"
	g_return_if_fail (adaptative_child != NULL);
#line 222 "../editor/adaptative-window.vala"
	adaptative_widget_set_window_size (adaptative_child, _data1_->new_window_size);
#line 725 "adaptative-window.c"
}

static void
___lambda5__gfunc (gconstpointer data,
                   gpointer self)
{
#line 222 "../editor/adaptative-window.vala"
	__lambda5_ (self, (AdaptativeWidget*) data);
#line 734 "adaptative-window.c"
}

static void
adaptative_window_change_window_size (AdaptativeWindow* self,
                                      AdaptativeWidgetWindowSize new_window_size)
{
	Block1Data* _data1_;
	GList* _tmp0_;
#line 217 "../editor/adaptative-window.vala"
	g_return_if_fail (self != NULL);
#line 217 "../editor/adaptative-window.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 217 "../editor/adaptative-window.vala"
	_data1_->_ref_count_ = 1;
#line 217 "../editor/adaptative-window.vala"
	_data1_->self = g_object_ref (self);
#line 217 "../editor/adaptative-window.vala"
	_data1_->new_window_size = new_window_size;
#line 219 "../editor/adaptative-window.vala"
	if (self->priv->window_size == _data1_->new_window_size) {
#line 220 "../editor/adaptative-window.vala"
		block1_data_unref (_data1_);
#line 220 "../editor/adaptative-window.vala"
		_data1_ = NULL;
#line 220 "../editor/adaptative-window.vala"
		return;
#line 761 "adaptative-window.c"
	}
#line 221 "../editor/adaptative-window.vala"
	self->priv->window_size = _data1_->new_window_size;
#line 222 "../editor/adaptative-window.vala"
	_tmp0_ = self->priv->adaptative_children;
#line 222 "../editor/adaptative-window.vala"
	g_list_foreach (_tmp0_, ___lambda5__gfunc, _data1_);
#line 217 "../editor/adaptative-window.vala"
	block1_data_unref (_data1_);
#line 217 "../editor/adaptative-window.vala"
	_data1_ = NULL;
#line 773 "adaptative-window.c"
}

static void
adaptative_window_set_style_classes (AdaptativeWindow* self,
                                     gboolean extra_thin_window,
                                     gboolean thin_window,
                                     gboolean large_window,
                                     gboolean extra_flat_window,
                                     gboolean flat_window)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
#line 235 "../editor/adaptative-window.vala"
	g_return_if_fail (self != NULL);
#line 239 "../editor/adaptative-window.vala"
	if (self->priv->has_extra_thin_window_class) {
#line 239 "../editor/adaptative-window.vala"
		_tmp0_ = !extra_thin_window;
#line 793 "adaptative-window.c"
	} else {
#line 239 "../editor/adaptative-window.vala"
		_tmp0_ = FALSE;
#line 797 "adaptative-window.c"
	}
#line 239 "../editor/adaptative-window.vala"
	if (_tmp0_) {
#line 240 "../editor/adaptative-window.vala"
		adaptative_window_set_style_class (self, "extra-thin-window", FALSE, &self->priv->has_extra_thin_window_class);
#line 803 "adaptative-window.c"
	}
#line 241 "../editor/adaptative-window.vala"
	if (self->priv->has_thin_window_class) {
#line 241 "../editor/adaptative-window.vala"
		_tmp1_ = !thin_window;
#line 809 "adaptative-window.c"
	} else {
#line 241 "../editor/adaptative-window.vala"
		_tmp1_ = FALSE;
#line 813 "adaptative-window.c"
	}
#line 241 "../editor/adaptative-window.vala"
	if (_tmp1_) {
#line 242 "../editor/adaptative-window.vala"
		adaptative_window_set_style_class (self, "thin-window", FALSE, &self->priv->has_thin_window_class);
#line 819 "adaptative-window.c"
	}
#line 244 "../editor/adaptative-window.vala"
	if (large_window != self->priv->has_large_window_class) {
#line 245 "../editor/adaptative-window.vala"
		adaptative_window_set_style_class (self, "large-window", large_window, &self->priv->has_large_window_class);
#line 825 "adaptative-window.c"
	}
#line 246 "../editor/adaptative-window.vala"
	if (thin_window != self->priv->has_thin_window_class) {
#line 247 "../editor/adaptative-window.vala"
		adaptative_window_set_style_class (self, "thin-window", thin_window, &self->priv->has_thin_window_class);
#line 831 "adaptative-window.c"
	}
#line 248 "../editor/adaptative-window.vala"
	if (extra_thin_window != self->priv->has_extra_thin_window_class) {
#line 249 "../editor/adaptative-window.vala"
		adaptative_window_set_style_class (self, "extra-thin-window", extra_thin_window, &self->priv->has_extra_thin_window_class);
#line 837 "adaptative-window.c"
	}
#line 252 "../editor/adaptative-window.vala"
	if (self->priv->has_extra_flat_window_class) {
#line 252 "../editor/adaptative-window.vala"
		_tmp2_ = !extra_flat_window;
#line 843 "adaptative-window.c"
	} else {
#line 252 "../editor/adaptative-window.vala"
		_tmp2_ = FALSE;
#line 847 "adaptative-window.c"
	}
#line 252 "../editor/adaptative-window.vala"
	if (_tmp2_) {
#line 253 "../editor/adaptative-window.vala"
		adaptative_window_set_style_class (self, "extra-flat-window", FALSE, &self->priv->has_extra_flat_window_class);
#line 853 "adaptative-window.c"
	}
#line 255 "../editor/adaptative-window.vala"
	if (flat_window != self->priv->has_flat_window_class) {
#line 256 "../editor/adaptative-window.vala"
		adaptative_window_set_style_class (self, "flat-window", flat_window, &self->priv->has_flat_window_class);
#line 859 "adaptative-window.c"
	}
#line 257 "../editor/adaptative-window.vala"
	if (extra_flat_window != self->priv->has_extra_flat_window_class) {
#line 258 "../editor/adaptative-window.vala"
		adaptative_window_set_style_class (self, "extra-flat-window", extra_flat_window, &self->priv->has_extra_flat_window_class);
#line 865 "adaptative-window.c"
	}
}

static inline void
adaptative_window_set_style_class (AdaptativeWindow* self,
                                   const gchar* class_name,
                                   gboolean new_state,
                                   gboolean* old_state)
{
#line 261 "../editor/adaptative-window.vala"
	g_return_if_fail (self != NULL);
#line 261 "../editor/adaptative-window.vala"
	g_return_if_fail (class_name != NULL);
#line 263 "../editor/adaptative-window.vala"
	*old_state = new_state;
#line 264 "../editor/adaptative-window.vala"
	if (new_state) {
#line 883 "adaptative-window.c"
		GtkStyleContext* _tmp0_;
#line 265 "../editor/adaptative-window.vala"
		_tmp0_ = self->priv->window_style_context;
#line 265 "../editor/adaptative-window.vala"
		gtk_style_context_add_class (_tmp0_, class_name);
#line 889 "adaptative-window.c"
	} else {
		GtkStyleContext* _tmp1_;
#line 267 "../editor/adaptative-window.vala"
		_tmp1_ = self->priv->window_style_context;
#line 267 "../editor/adaptative-window.vala"
		gtk_style_context_remove_class (_tmp1_, class_name);
#line 896 "adaptative-window.c"
	}
}

static void
adaptative_window_load_window_state (AdaptativeWindow* self)
{
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	GSettings* _tmp2_;
#line 292 "../editor/adaptative-window.vala"
	g_return_if_fail (self != NULL);
#line 294 "../editor/adaptative-window.vala"
	_tmp0_ = self->priv->settings;
#line 294 "../editor/adaptative-window.vala"
	if (g_settings_get_boolean (_tmp0_, "window-is-maximized")) {
#line 295 "../editor/adaptative-window.vala"
		gtk_window_maximize ((GtkWindow*) self);
#line 914 "adaptative-window.c"
	}
#line 296 "../editor/adaptative-window.vala"
	_tmp1_ = self->priv->settings;
#line 296 "../editor/adaptative-window.vala"
	_tmp2_ = self->priv->settings;
#line 296 "../editor/adaptative-window.vala"
	gtk_window_set_default_size ((GtkWindow*) self, g_settings_get_int (_tmp1_, "window-width"), g_settings_get_int (_tmp2_, "window-height"));
#line 922 "adaptative-window.c"
}

static gint*
_int_dup (gint* self)
{
	gint* dup;
#line 305 "../editor/adaptative-window.vala"
	dup = g_new0 (gint, 1);
#line 305 "../editor/adaptative-window.vala"
	memcpy (dup, self, sizeof (gint));
#line 305 "../editor/adaptative-window.vala"
	return dup;
#line 935 "adaptative-window.c"
}

static gpointer
__int_dup0 (gpointer self)
{
#line 305 "../editor/adaptative-window.vala"
	return self ? _int_dup (self) : NULL;
#line 943 "adaptative-window.c"
}

static void
adaptative_window_update_window_state (AdaptativeWindow* self)
{
	gboolean _tmp0_ = FALSE;
	gint* _window_width = NULL;
	gint* _window_height = NULL;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_;
	gint* _tmp4_;
	gint _tmp5_;
	gint* _tmp6_;
	gboolean _tmp7_ = FALSE;
	gint* _tmp8_;
	gint* _tmp10_;
	gint* _tmp11_;
#line 299 "../editor/adaptative-window.vala"
	g_return_if_fail (self != NULL);
#line 301 "../editor/adaptative-window.vala"
	if (self->priv->window_is_maximized) {
#line 301 "../editor/adaptative-window.vala"
		_tmp0_ = TRUE;
#line 968 "adaptative-window.c"
	} else {
#line 301 "../editor/adaptative-window.vala"
		_tmp0_ = self->priv->window_is_tiled;
#line 972 "adaptative-window.c"
	}
#line 301 "../editor/adaptative-window.vala"
	if (_tmp0_) {
#line 302 "../editor/adaptative-window.vala"
		return;
#line 978 "adaptative-window.c"
	}
#line 303 "../editor/adaptative-window.vala"
	_window_width = NULL;
#line 304 "../editor/adaptative-window.vala"
	_window_height = NULL;
#line 305 "../editor/adaptative-window.vala"
	gtk_window_get_size ((GtkWindow*) self, &_tmp1_, &_tmp2_);
#line 305 "../editor/adaptative-window.vala"
	_g_free0 (_window_width);
#line 305 "../editor/adaptative-window.vala"
	_tmp3_ = _tmp1_;
#line 305 "../editor/adaptative-window.vala"
	_tmp4_ = __int_dup0 (&_tmp3_);
#line 305 "../editor/adaptative-window.vala"
	_window_width = _tmp4_;
#line 305 "../editor/adaptative-window.vala"
	_g_free0 (_window_height);
#line 305 "../editor/adaptative-window.vala"
	_tmp5_ = _tmp2_;
#line 305 "../editor/adaptative-window.vala"
	_tmp6_ = __int_dup0 (&_tmp5_);
#line 305 "../editor/adaptative-window.vala"
	_window_height = _tmp6_;
#line 306 "../editor/adaptative-window.vala"
	_tmp8_ = _window_width;
#line 306 "../editor/adaptative-window.vala"
	if (_tmp8_ == NULL) {
#line 306 "../editor/adaptative-window.vala"
		_tmp7_ = TRUE;
#line 1008 "adaptative-window.c"
	} else {
		gint* _tmp9_;
#line 306 "../editor/adaptative-window.vala"
		_tmp9_ = _window_height;
#line 306 "../editor/adaptative-window.vala"
		_tmp7_ = _tmp9_ == NULL;
#line 1015 "adaptative-window.c"
	}
#line 306 "../editor/adaptative-window.vala"
	if (_tmp7_) {
#line 307 "../editor/adaptative-window.vala"
		_g_free0 (_window_height);
#line 307 "../editor/adaptative-window.vala"
		_g_free0 (_window_width);
#line 307 "../editor/adaptative-window.vala"
		return;
#line 1025 "adaptative-window.c"
	}
#line 308 "../editor/adaptative-window.vala"
	_tmp10_ = _window_width;
#line 308 "../editor/adaptative-window.vala"
	self->priv->window_width = (gint) (*_tmp10_);
#line 309 "../editor/adaptative-window.vala"
	_tmp11_ = _window_height;
#line 309 "../editor/adaptative-window.vala"
	self->priv->window_height = (gint) (*_tmp11_);
#line 299 "../editor/adaptative-window.vala"
	_g_free0 (_window_height);
#line 299 "../editor/adaptative-window.vala"
	_g_free0 (_window_width);
#line 1039 "adaptative-window.c"
}

static void
adaptative_window_save_window_state (AdaptativeWindow* self)
{
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	GSettings* _tmp4_;
#line 312 "../editor/adaptative-window.vala"
	g_return_if_fail (self != NULL);
#line 314 "../editor/adaptative-window.vala"
	_tmp0_ = self->priv->settings;
#line 314 "../editor/adaptative-window.vala"
	g_settings_delay (_tmp0_);
#line 315 "../editor/adaptative-window.vala"
	_tmp1_ = self->priv->settings;
#line 315 "../editor/adaptative-window.vala"
	g_settings_set_int (_tmp1_, "window-width", self->priv->window_width);
#line 316 "../editor/adaptative-window.vala"
	_tmp2_ = self->priv->settings;
#line 316 "../editor/adaptative-window.vala"
	g_settings_set_int (_tmp2_, "window-height", self->priv->window_height);
#line 317 "../editor/adaptative-window.vala"
	_tmp3_ = self->priv->settings;
#line 317 "../editor/adaptative-window.vala"
	g_settings_set_boolean (_tmp3_, "window-is-maximized", self->priv->window_is_maximized);
#line 318 "../editor/adaptative-window.vala"
	_tmp4_ = self->priv->settings;
#line 318 "../editor/adaptative-window.vala"
	g_settings_apply (_tmp4_);
#line 1072 "adaptative-window.c"
}

static void
_adaptative_window_update_highcontrast_state_g_object_notify (GObject* _sender,
                                                              GParamSpec* pspec,
                                                              gpointer self)
{
#line 334 "../editor/adaptative-window.vala"
	adaptative_window_update_highcontrast_state ((AdaptativeWindow*) self, _sender, pspec);
#line 1082 "adaptative-window.c"
}

static void
adaptative_window_manage_high_contrast (AdaptativeWindow* self)
{
	GtkSettings* nullable_gtk_settings = NULL;
	GtkSettings* _tmp0_;
	GtkSettings* _tmp1_;
	GtkSettings* _tmp2_;
	GtkSettings* gtk_settings = NULL;
	GtkSettings* _tmp3_;
	GtkSettings* _tmp4_;
	GtkSettings* _tmp5_;
	GtkSettings* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
#line 327 "../editor/adaptative-window.vala"
	g_return_if_fail (self != NULL);
#line 329 "../editor/adaptative-window.vala"
	_tmp0_ = gtk_settings_get_default ();
#line 329 "../editor/adaptative-window.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 329 "../editor/adaptative-window.vala"
	nullable_gtk_settings = _tmp1_;
#line 330 "../editor/adaptative-window.vala"
	_tmp2_ = nullable_gtk_settings;
#line 330 "../editor/adaptative-window.vala"
	if (_tmp2_ == NULL) {
#line 331 "../editor/adaptative-window.vala"
		_g_object_unref0 (nullable_gtk_settings);
#line 331 "../editor/adaptative-window.vala"
		return;
#line 1116 "adaptative-window.c"
	}
#line 333 "../editor/adaptative-window.vala"
	_tmp3_ = nullable_gtk_settings;
#line 333 "../editor/adaptative-window.vala"
	_tmp4_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_settings_get_type (), GtkSettings));
#line 333 "../editor/adaptative-window.vala"
	gtk_settings = _tmp4_;
#line 334 "../editor/adaptative-window.vala"
	_tmp5_ = gtk_settings;
#line 334 "../editor/adaptative-window.vala"
	g_signal_connect_object ((GObject*) _tmp5_, "notify::gtk-theme-name", (GCallback) _adaptative_window_update_highcontrast_state_g_object_notify, self, 0);
#line 335 "../editor/adaptative-window.vala"
	_tmp6_ = gtk_settings;
#line 335 "../editor/adaptative-window.vala"
	g_object_get (_tmp6_, "gtk-theme-name", &_tmp7_, NULL);
#line 335 "../editor/adaptative-window.vala"
	_tmp8_ = _tmp7_;
#line 335 "../editor/adaptative-window.vala"
	_tmp9_ = _tmp8_;
#line 335 "../editor/adaptative-window.vala"
	_adaptative_window_update_highcontrast_state (self, _tmp9_);
#line 335 "../editor/adaptative-window.vala"
	_g_free0 (_tmp9_);
#line 327 "../editor/adaptative-window.vala"
	_g_object_unref0 (gtk_settings);
#line 327 "../editor/adaptative-window.vala"
	_g_object_unref0 (nullable_gtk_settings);
#line 1144 "adaptative-window.c"
}

static void
adaptative_window_update_highcontrast_state (AdaptativeWindow* self,
                                             GObject* gtk_settings,
                                             GParamSpec* unused)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 338 "../editor/adaptative-window.vala"
	g_return_if_fail (self != NULL);
#line 338 "../editor/adaptative-window.vala"
	g_return_if_fail (gtk_settings != NULL);
#line 338 "../editor/adaptative-window.vala"
	g_return_if_fail (unused != NULL);
#line 340 "../editor/adaptative-window.vala"
	g_object_get (G_TYPE_CHECK_INSTANCE_CAST (gtk_settings, gtk_settings_get_type (), GtkSettings), "gtk-theme-name", &_tmp0_, NULL);
#line 340 "../editor/adaptative-window.vala"
	_tmp1_ = _tmp0_;
#line 340 "../editor/adaptative-window.vala"
	_tmp2_ = _tmp1_;
#line 340 "../editor/adaptative-window.vala"
	_adaptative_window_update_highcontrast_state (self, _tmp2_);
#line 340 "../editor/adaptative-window.vala"
	_g_free0 (_tmp2_);
#line 341 "../editor/adaptative-window.vala"
	g_signal_emit (self, adaptative_window_signals[ADAPTATIVE_WINDOW_GTK_THEME_CHANGED_SIGNAL], 0);
#line 1173 "adaptative-window.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1585 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1585 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1585 "glib-2.0.vapi"
	return result;
#line 1192 "adaptative-window.c"
}

static void
_adaptative_window_update_highcontrast_state (AdaptativeWindow* self,
                                              const gchar* theme_name)
{
	gboolean highcontrast_new_state = FALSE;
	BaseHeaderBar* _tmp0_;
#line 345 "../editor/adaptative-window.vala"
	g_return_if_fail (self != NULL);
#line 345 "../editor/adaptative-window.vala"
	g_return_if_fail (theme_name != NULL);
#line 347 "../editor/adaptative-window.vala"
	highcontrast_new_state = string_contains (theme_name, "HighContrast");
#line 348 "../editor/adaptative-window.vala"
	if (highcontrast_new_state == self->priv->highcontrast_state) {
#line 349 "../editor/adaptative-window.vala"
		return;
#line 1211 "adaptative-window.c"
	}
#line 350 "../editor/adaptative-window.vala"
	self->priv->highcontrast_state = highcontrast_new_state;
#line 351 "../editor/adaptative-window.vala"
	_tmp0_ = self->priv->headerbar;
#line 351 "../editor/adaptative-window.vala"
	base_header_bar_update_hamburger_menu (_tmp0_);
#line 353 "../editor/adaptative-window.vala"
	if (highcontrast_new_state) {
#line 1221 "adaptative-window.c"
		GtkStyleContext* _tmp1_;
#line 354 "../editor/adaptative-window.vala"
		_tmp1_ = self->priv->window_style_context;
#line 354 "../editor/adaptative-window.vala"
		gtk_style_context_add_class (_tmp1_, "hc-theme");
#line 1227 "adaptative-window.c"
	} else {
		GtkStyleContext* _tmp2_;
#line 356 "../editor/adaptative-window.vala"
		_tmp2_ = self->priv->window_style_context;
#line 356 "../editor/adaptative-window.vala"
		gtk_style_context_remove_class (_tmp2_, "hc-theme");
#line 1234 "adaptative-window.c"
	}
}

AdaptativeWindow*
adaptative_window_construct (GType object_type)
{
	AdaptativeWindow * self = NULL;
#line 74 "../editor/adaptative-window.vala"
	self = (AdaptativeWindow*) g_object_new (object_type, NULL);
#line 74 "../editor/adaptative-window.vala"
	return self;
#line 1246 "adaptative-window.c"
}

BaseHeaderBar*
adaptative_window_get_nta_headerbar (AdaptativeWindow* self)
{
	BaseHeaderBar* result;
	BaseHeaderBar* _tmp0_;
#line 79 "../editor/adaptative-window.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 79 "../editor/adaptative-window.vala"
	_tmp0_ = self->priv->headerbar;
#line 79 "../editor/adaptative-window.vala"
	result = _tmp0_;
#line 79 "../editor/adaptative-window.vala"
	return result;
#line 1262 "adaptative-window.c"
}

static void
adaptative_window_set_nta_headerbar (AdaptativeWindow* self,
                                     BaseHeaderBar* value)
{
	BaseHeaderBar* _value = NULL;
	BaseHeaderBar* _tmp0_;
	BaseHeaderBar* _tmp1_;
#line 80 "../editor/adaptative-window.vala"
	g_return_if_fail (self != NULL);
#line 82 "../editor/adaptative-window.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 82 "../editor/adaptative-window.vala"
	_value = _tmp0_;
#line 83 "../editor/adaptative-window.vala"
	if (_value == NULL) {
#line 84 "../editor/adaptative-window.vala"
		g_assert_not_reached ();
#line 1282 "adaptative-window.c"
	}
#line 86 "../editor/adaptative-window.vala"
	_tmp1_ = _g_object_ref0 (value);
#line 86 "../editor/adaptative-window.vala"
	_g_object_unref0 (self->priv->headerbar);
#line 86 "../editor/adaptative-window.vala"
	self->priv->headerbar = _tmp1_;
#line 87 "../editor/adaptative-window.vala"
	gtk_widget_show ((GtkWidget*) value);
#line 88 "../editor/adaptative-window.vala"
	gtk_window_set_titlebar ((GtkWindow*) self, (GtkWidget*) value);
#line 80 "../editor/adaptative-window.vala"
	_g_object_unref0 (_value);
#line 1296 "adaptative-window.c"
}

static void
adaptative_window_set_window_title (AdaptativeWindow* self,
                                    const gchar* value)
{
	gchar* _value = NULL;
	gchar* _tmp0_;
#line 94 "../editor/adaptative-window.vala"
	g_return_if_fail (self != NULL);
#line 96 "../editor/adaptative-window.vala"
	_tmp0_ = g_strdup (value);
#line 96 "../editor/adaptative-window.vala"
	_value = _tmp0_;
#line 97 "../editor/adaptative-window.vala"
	if (_value == NULL) {
#line 98 "../editor/adaptative-window.vala"
		g_assert_not_reached ();
#line 1315 "adaptative-window.c"
	}
#line 100 "../editor/adaptative-window.vala"
	gtk_window_set_title ((GtkWindow*) self, value);
#line 94 "../editor/adaptative-window.vala"
	_g_free0 (_value);
#line 1321 "adaptative-window.c"
}

static void
adaptative_window_set_specific_css_class_or_empty (AdaptativeWindow* self,
                                                   const gchar* value)
{
	gchar* _value = NULL;
	gchar* _tmp0_;
	GtkStyleContext* _tmp1_;
	GtkStyleContext* _tmp2_;
#line 107 "../editor/adaptative-window.vala"
	g_return_if_fail (self != NULL);
#line 109 "../editor/adaptative-window.vala"
	_tmp0_ = g_strdup (value);
#line 109 "../editor/adaptative-window.vala"
	_value = _tmp0_;
#line 110 "../editor/adaptative-window.vala"
	if (_value == NULL) {
#line 111 "../editor/adaptative-window.vala"
		g_assert_not_reached ();
#line 1342 "adaptative-window.c"
	}
#line 113 "../editor/adaptative-window.vala"
	_tmp1_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 113 "../editor/adaptative-window.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 113 "../editor/adaptative-window.vala"
	_g_object_unref0 (self->priv->window_style_context);
#line 113 "../editor/adaptative-window.vala"
	self->priv->window_style_context = _tmp2_;
#line 114 "../editor/adaptative-window.vala"
	if (g_strcmp0 (value, "") != 0) {
#line 1354 "adaptative-window.c"
		GtkStyleContext* _tmp3_;
#line 115 "../editor/adaptative-window.vala"
		_tmp3_ = self->priv->window_style_context;
#line 115 "../editor/adaptative-window.vala"
		gtk_style_context_add_class (_tmp3_, value);
#line 1360 "adaptative-window.c"
	}
#line 107 "../editor/adaptative-window.vala"
	_g_free0 (_value);
#line 1364 "adaptative-window.c"
}

static void
adaptative_window_set_schema_path (AdaptativeWindow* self,
                                   const gchar* value)
{
	gchar* _value = NULL;
	gchar* _tmp0_;
	GSettings* _tmp1_;
#line 276 "../editor/adaptative-window.vala"
	g_return_if_fail (self != NULL);
#line 278 "../editor/adaptative-window.vala"
	_tmp0_ = g_strdup (value);
#line 278 "../editor/adaptative-window.vala"
	_value = _tmp0_;
#line 279 "../editor/adaptative-window.vala"
	if (_value == NULL) {
#line 280 "../editor/adaptative-window.vala"
		g_assert_not_reached ();
#line 1384 "adaptative-window.c"
	}
#line 282 "../editor/adaptative-window.vala"
	_tmp1_ = g_settings_new_with_path ("ca.desrt.dconf-editor.Lib", value);
#line 282 "../editor/adaptative-window.vala"
	_g_object_unref0 (self->priv->settings);
#line 282 "../editor/adaptative-window.vala"
	self->priv->settings = _tmp1_;
#line 276 "../editor/adaptative-window.vala"
	_g_free0 (_value);
#line 1394 "adaptative-window.c"
}

static gboolean
_adaptative_window___lambda6_ (AdaptativeWindow* self)
{
	GtkStyleContext* _tmp0_;
	gboolean result;
#line 128 "../editor/adaptative-window.vala"
	_tmp0_ = self->priv->window_style_context;
#line 128 "../editor/adaptative-window.vala"
	gtk_style_context_remove_class (_tmp0_, "startup");
#line 128 "../editor/adaptative-window.vala"
	result = G_SOURCE_REMOVE;
#line 128 "../editor/adaptative-window.vala"
	return result;
#line 1410 "adaptative-window.c"
}

static gboolean
__adaptative_window___lambda6__gsource_func (gpointer self)
{
	gboolean result;
	result = _adaptative_window___lambda6_ ((AdaptativeWindow*) self);
#line 128 "../editor/adaptative-window.vala"
	return result;
#line 1420 "adaptative-window.c"
}

static GObject *
adaptative_window_constructor (GType type,
                               guint n_construct_properties,
                               GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	AdaptativeWindow * self;
	GtkStyleContext* _tmp0_;
#line 119 "../editor/adaptative-window.vala"
	parent_class = G_OBJECT_CLASS (adaptative_window_parent_class);
#line 119 "../editor/adaptative-window.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 119 "../editor/adaptative-window.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ADAPTATIVE_WINDOW, AdaptativeWindow);
#line 122 "../editor/adaptative-window.vala"
	_tmp0_ = self->priv->window_style_context;
#line 122 "../editor/adaptative-window.vala"
	gtk_style_context_add_class (_tmp0_, "startup");
#line 124 "../editor/adaptative-window.vala"
	adaptative_window_manage_high_contrast (self);
#line 126 "../editor/adaptative-window.vala"
	adaptative_window_load_window_state (self);
#line 128 "../editor/adaptative-window.vala"
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 300, __adaptative_window___lambda6__gsource_func, g_object_ref (self), g_object_unref);
#line 119 "../editor/adaptative-window.vala"
	return obj;
#line 1450 "adaptative-window.c"
}

static void
adaptative_window_class_init (AdaptativeWindowClass * klass,
                              gpointer klass_data)
{
#line 74 "../editor/adaptative-window.vala"
	adaptative_window_parent_class = g_type_class_peek_parent (klass);
#line 74 "../editor/adaptative-window.vala"
	g_type_class_adjust_private_offset (klass, &AdaptativeWindow_private_offset);
#line 74 "../editor/adaptative-window.vala"
	((AdaptativeWindowClass *) klass)->before_destroy = (void (*) (AdaptativeWindow*)) adaptative_window_real_before_destroy;
#line 74 "../editor/adaptative-window.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_adaptative_window_get_property;
#line 74 "../editor/adaptative-window.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_adaptative_window_set_property;
#line 74 "../editor/adaptative-window.vala"
	G_OBJECT_CLASS (klass)->constructor = adaptative_window_constructor;
#line 74 "../editor/adaptative-window.vala"
	G_OBJECT_CLASS (klass)->finalize = adaptative_window_finalize;
#line 74 "../editor/adaptative-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ADAPTATIVE_WINDOW_NTA_HEADERBAR_PROPERTY, adaptative_window_properties[ADAPTATIVE_WINDOW_NTA_HEADERBAR_PROPERTY] = g_param_spec_object ("nta-headerbar", "nta-headerbar", "nta-headerbar", TYPE_BASE_HEADER_BAR, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY | G_PARAM_EXPLICIT_NOTIFY));
#line 74 "../editor/adaptative-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ADAPTATIVE_WINDOW_WINDOW_TITLE_PROPERTY, adaptative_window_properties[ADAPTATIVE_WINDOW_WINDOW_TITLE_PROPERTY] = g_param_spec_string ("window-title", "window-title", "window-title", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY | G_PARAM_EXPLICIT_NOTIFY));
#line 74 "../editor/adaptative-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ADAPTATIVE_WINDOW_SPECIFIC_CSS_CLASS_OR_EMPTY_PROPERTY, adaptative_window_properties[ADAPTATIVE_WINDOW_SPECIFIC_CSS_CLASS_OR_EMPTY_PROPERTY] = g_param_spec_string ("specific-css-class-or-empty", "specific-css-class-or-empty", "specific-css-class-or-empty", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY | G_PARAM_EXPLICIT_NOTIFY));
#line 74 "../editor/adaptative-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ADAPTATIVE_WINDOW_SCHEMA_PATH_PROPERTY, adaptative_window_properties[ADAPTATIVE_WINDOW_SCHEMA_PATH_PROPERTY] = g_param_spec_string ("schema-path", "schema-path", "schema-path", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY | G_PARAM_EXPLICIT_NOTIFY));
#line 74 "../editor/adaptative-window.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/ca/desrt/dconf-editor/ui/adaptative-window.ui");
#line 74 "../editor/adaptative-window.vala"
	adaptative_window_signals[ADAPTATIVE_WINDOW_GTK_THEME_CHANGED_SIGNAL] = g_signal_new ("gtk-theme-changed", TYPE_ADAPTATIVE_WINDOW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 74 "../editor/adaptative-window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_window_state_event", G_CALLBACK(_adaptative_window_on_window_state_event_gtk_widget_window_state_event));
#line 74 "../editor/adaptative-window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_size_allocate", G_CALLBACK(_adaptative_window_on_size_allocate_gtk_widget_size_allocate));
#line 74 "../editor/adaptative-window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_destroy", G_CALLBACK(_adaptative_window_on_destroy_gtk_widget_destroy));
#line 1489 "adaptative-window.c"
}

static void
adaptative_window_instance_init (AdaptativeWindow * self,
                                 gpointer klass)
{
#line 74 "../editor/adaptative-window.vala"
	self->priv = adaptative_window_get_instance_private (self);
#line 177 "../editor/adaptative-window.vala"
	self->priv->window_size = ADAPTATIVE_WIDGET_WINDOW_SIZE_START_SIZE;
#line 179 "../editor/adaptative-window.vala"
	self->priv->adaptative_children = NULL;
#line 229 "../editor/adaptative-window.vala"
	self->priv->has_extra_thin_window_class = FALSE;
#line 230 "../editor/adaptative-window.vala"
	self->priv->has_thin_window_class = FALSE;
#line 231 "../editor/adaptative-window.vala"
	self->priv->has_large_window_class = FALSE;
#line 232 "../editor/adaptative-window.vala"
	self->priv->has_extra_flat_window_class = FALSE;
#line 233 "../editor/adaptative-window.vala"
	self->priv->has_flat_window_class = FALSE;
#line 287 "../editor/adaptative-window.vala"
	self->priv->window_width = 0;
#line 288 "../editor/adaptative-window.vala"
	self->priv->window_height = 0;
#line 289 "../editor/adaptative-window.vala"
	self->priv->window_is_maximized = FALSE;
#line 290 "../editor/adaptative-window.vala"
	self->priv->window_is_tiled = FALSE;
#line 344 "../editor/adaptative-window.vala"
	self->priv->highcontrast_state = FALSE;
#line 74 "../editor/adaptative-window.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 1524 "adaptative-window.c"
}

static void
adaptative_window_finalize (GObject * obj)
{
	AdaptativeWindow * self;
#line 74 "../editor/adaptative-window.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ADAPTATIVE_WINDOW, AdaptativeWindow);
#line 76 "../editor/adaptative-window.vala"
	_g_object_unref0 (self->priv->headerbar);
#line 104 "../editor/adaptative-window.vala"
	_g_object_unref0 (self->priv->window_style_context);
#line 179 "../editor/adaptative-window.vala"
	(self->priv->adaptative_children == NULL) ? NULL : (self->priv->adaptative_children = (_g_list_free__g_object_unref0_ (self->priv->adaptative_children), NULL));
#line 285 "../editor/adaptative-window.vala"
	_g_object_unref0 (self->priv->settings);
#line 74 "../editor/adaptative-window.vala"
	G_OBJECT_CLASS (adaptative_window_parent_class)->finalize (obj);
#line 1543 "adaptative-window.c"
}

static GType
adaptative_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (AdaptativeWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) adaptative_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AdaptativeWindow), 0, (GInstanceInitFunc) adaptative_window_instance_init, NULL };
	GType adaptative_window_type_id;
	adaptative_window_type_id = g_type_register_static (gtk_application_window_get_type (), "AdaptativeWindow", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	AdaptativeWindow_private_offset = g_type_add_instance_private (adaptative_window_type_id, sizeof (AdaptativeWindowPrivate));
	return adaptative_window_type_id;
}

GType
adaptative_window_get_type (void)
{
	static volatile gsize adaptative_window_type_id__once = 0;
	if (g_once_init_enter (&adaptative_window_type_id__once)) {
		GType adaptative_window_type_id;
		adaptative_window_type_id = adaptative_window_get_type_once ();
		g_once_init_leave (&adaptative_window_type_id__once, adaptative_window_type_id);
	}
	return adaptative_window_type_id__once;
}

static void
_vala_adaptative_window_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	AdaptativeWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_ADAPTATIVE_WINDOW, AdaptativeWindow);
#line 74 "../editor/adaptative-window.vala"
	switch (property_id) {
#line 74 "../editor/adaptative-window.vala"
		case ADAPTATIVE_WINDOW_NTA_HEADERBAR_PROPERTY:
#line 74 "../editor/adaptative-window.vala"
		g_value_set_object (value, adaptative_window_get_nta_headerbar (self));
#line 74 "../editor/adaptative-window.vala"
		break;
#line 1584 "adaptative-window.c"
		default:
#line 74 "../editor/adaptative-window.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 74 "../editor/adaptative-window.vala"
		break;
#line 1590 "adaptative-window.c"
	}
}

static void
_vala_adaptative_window_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec)
{
	AdaptativeWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_ADAPTATIVE_WINDOW, AdaptativeWindow);
#line 74 "../editor/adaptative-window.vala"
	switch (property_id) {
#line 74 "../editor/adaptative-window.vala"
		case ADAPTATIVE_WINDOW_NTA_HEADERBAR_PROPERTY:
#line 74 "../editor/adaptative-window.vala"
		adaptative_window_set_nta_headerbar (self, g_value_get_object (value));
#line 74 "../editor/adaptative-window.vala"
		break;
#line 74 "../editor/adaptative-window.vala"
		case ADAPTATIVE_WINDOW_WINDOW_TITLE_PROPERTY:
#line 74 "../editor/adaptative-window.vala"
		adaptative_window_set_window_title (self, g_value_get_string (value));
#line 74 "../editor/adaptative-window.vala"
		break;
#line 74 "../editor/adaptative-window.vala"
		case ADAPTATIVE_WINDOW_SPECIFIC_CSS_CLASS_OR_EMPTY_PROPERTY:
#line 74 "../editor/adaptative-window.vala"
		adaptative_window_set_specific_css_class_or_empty (self, g_value_get_string (value));
#line 74 "../editor/adaptative-window.vala"
		break;
#line 74 "../editor/adaptative-window.vala"
		case ADAPTATIVE_WINDOW_SCHEMA_PATH_PROPERTY:
#line 74 "../editor/adaptative-window.vala"
		adaptative_window_set_schema_path (self, g_value_get_string (value));
#line 74 "../editor/adaptative-window.vala"
		break;
#line 1628 "adaptative-window.c"
		default:
#line 74 "../editor/adaptative-window.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 74 "../editor/adaptative-window.vala"
		break;
#line 1634 "adaptative-window.c"
	}
}

