/* short-pathbar.c generated by valac 0.56.17, the Vala compiler
 * generated from short-pathbar.vala, do not modify */

/*
  This file is part of Dconf Editor

  Dconf Editor is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  Dconf Editor is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Dconf Editor.  If not, see <https://www.gnu.org/licenses/>.
*/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <cairo-gobject.h>
#include <gio/gio.h>

#define MODEL_UTILS_folder_context_id_string "1"
#define MODEL_UTILS_folder_context_id ((guint16) 1)
#define MODEL_UTILS_undefined_context_id ((guint16) 0)
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_PATHBAR (pathbar_get_type ())
#define PATHBAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PATHBAR, Pathbar))
#define IS_PATHBAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PATHBAR))
#define PATHBAR_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_PATHBAR, PathbarIface))

typedef struct _Pathbar Pathbar;
typedef struct _PathbarIface PathbarIface;
typedef enum  {
	VIEW_TYPE_OBJECT,
	VIEW_TYPE_FOLDER,
	VIEW_TYPE_SEARCH,
	VIEW_TYPE_CONFIG
} ViewType;

#define TYPE_VIEW_TYPE (view_type_get_type ())

#define TYPE_SHORT_PATHBAR (short_pathbar_get_type ())
#define SHORT_PATHBAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SHORT_PATHBAR, ShortPathbar))
#define SHORT_PATHBAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SHORT_PATHBAR, ShortPathbarClass))
#define IS_SHORT_PATHBAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SHORT_PATHBAR))
#define IS_SHORT_PATHBAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SHORT_PATHBAR))
#define SHORT_PATHBAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SHORT_PATHBAR, ShortPathbarClass))

typedef struct _ShortPathbar ShortPathbar;
typedef struct _ShortPathbarClass ShortPathbarClass;
typedef struct _ShortPathbarPrivate ShortPathbarPrivate;
enum  {
	SHORT_PATHBAR_0_PROPERTY,
	SHORT_PATHBAR_NUM_PROPERTIES
};
static GParamSpec* short_pathbar_properties[SHORT_PATHBAR_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))

struct _PathbarIface {
	GTypeInterface parent_iface;
	gboolean (*has_popover) (Pathbar* self);
	void (*close_menu) (Pathbar* self);
	void (*toggle_menu) (Pathbar* self);
	void (*set_path) (Pathbar* self, ViewType type, const gchar* path);
	void (*update_ghosts) (Pathbar* self, const gchar* non_ghost_path, gboolean is_search);
	void (*get_complete_path) (Pathbar* self, gchar** _complete_path);
	void (*get_fallback_path_and_complete_path) (Pathbar* self, gchar** _fallback_path, gchar** _complete_path);
	gchar* (*get_selected_child) (Pathbar* self, const gchar* current_path);
};

struct _ShortPathbar {
	GtkGrid parent_instance;
	ShortPathbarPrivate * priv;
};

struct _ShortPathbarClass {
	GtkGridClass parent_class;
};

struct _ShortPathbarPrivate {
	gchar* non_ghost_path;
	gchar* complete_path;
	GtkMenuButton* menu_button;
	GtkLabel* view_label;
	gint event_x;
};

static gint ShortPathbar_private_offset;
static gpointer short_pathbar_parent_class = NULL;
static PathbarIface * short_pathbar_pathbar_parent_iface = NULL;

VALA_EXTERN GType view_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType pathbar_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType short_pathbar_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ShortPathbar, g_object_unref)
static void short_pathbar_real_get_complete_path (Pathbar* base,
                                           gchar** _complete_path);
static void short_pathbar_real_get_fallback_path_and_complete_path (Pathbar* base,
                                                             gchar** _fallback_path,
                                                             gchar** _complete_path);
VALA_EXTERN gboolean model_utils_is_folder_path (const gchar* path);
VALA_EXTERN ShortPathbar* short_pathbar_new (const gchar* complete_path_or_empty,
                                 ViewType type,
                                 const gchar* path);
VALA_EXTERN ShortPathbar* short_pathbar_construct (GType object_type,
                                       const gchar* complete_path_or_empty,
                                       ViewType type,
                                       const gchar* path);
VALA_EXTERN void pathbar_set_path (Pathbar* self,
                       ViewType type,
                       const gchar* path);
static gboolean short_pathbar_on_button_press_event (ShortPathbar* self,
                                              GtkWidget* widget,
                                              GdkEventButton* event);
static gboolean _short_pathbar_on_button_press_event_gtk_widget_button_press_event (GtkWidget* _sender,
                                                                             GdkEventButton* event,
                                                                             gpointer self);
static void short_pathbar_on_button_clicked (ShortPathbar* self,
                                      GtkButton* button);
static void _short_pathbar_on_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                          gpointer self);
static gboolean short_pathbar_real_has_popover (Pathbar* base);
static void short_pathbar_real_close_menu (Pathbar* base);
static void short_pathbar_real_toggle_menu (Pathbar* base);
static void short_pathbar_real_set_path (Pathbar* base,
                                  ViewType type,
                                  const gchar* path);
VALA_EXTERN gchar* model_utils_get_name (const gchar* path);
static void short_pathbar_update_menu (ShortPathbar* self);
static void short_pathbar_real_update_ghosts (Pathbar* base,
                                       const gchar* _non_ghost_path,
                                       gboolean is_search);
static void _short_pathbar_update_menu (const gchar* complete_path,
                                 const gchar* non_ghost_path,
                                 GMenu** menu);
static gchar** _vala_array_dup14 (gchar** self,
                           gssize length);
VALA_EXTERN void pathbar_populate_pathbar_menu (gboolean is_folder,
                                    GMenu** menu);
VALA_EXTERN void pathbar_get_complete_path (Pathbar* self,
                                gchar** _complete_path);
VALA_EXTERN void pathbar_get_fallback_path_and_complete_path (Pathbar* self,
                                                  gchar** _fallback_path,
                                                  gchar** _complete_path);
VALA_EXTERN gboolean pathbar_has_popover (Pathbar* self);
VALA_EXTERN void pathbar_close_menu (Pathbar* self);
VALA_EXTERN void pathbar_toggle_menu (Pathbar* self);
VALA_EXTERN void pathbar_update_ghosts (Pathbar* self,
                            const gchar* non_ghost_path,
                            gboolean is_search);
static void short_pathbar_finalize (GObject * obj);
static GType short_pathbar_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
short_pathbar_get_instance_private (ShortPathbar* self)
{
	return G_STRUCT_MEMBER_P (self, ShortPathbar_private_offset);
}

static void
short_pathbar_real_get_complete_path (Pathbar* base,
                                      gchar** _complete_path)
{
	ShortPathbar * self;
	gchar* _vala__complete_path = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 26 "../editor/short-pathbar.vala"
	self = (ShortPathbar*) base;
#line 28 "../editor/short-pathbar.vala"
	_tmp0_ = self->priv->complete_path;
#line 28 "../editor/short-pathbar.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 28 "../editor/short-pathbar.vala"
	_g_free0 (_vala__complete_path);
#line 28 "../editor/short-pathbar.vala"
	_vala__complete_path = _tmp1_;
#line 26 "../editor/short-pathbar.vala"
	if (_complete_path) {
#line 26 "../editor/short-pathbar.vala"
		*_complete_path = _vala__complete_path;
#line 219 "short-pathbar.c"
	} else {
#line 26 "../editor/short-pathbar.vala"
		_g_free0 (_vala__complete_path);
#line 223 "short-pathbar.c"
	}
}

static void
short_pathbar_real_get_fallback_path_and_complete_path (Pathbar* base,
                                                        gchar** _fallback_path,
                                                        gchar** _complete_path)
{
	ShortPathbar * self;
	gchar* _vala__fallback_path = NULL;
	gchar* _vala__complete_path = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
#line 30 "../editor/short-pathbar.vala"
	self = (ShortPathbar*) base;
#line 32 "../editor/short-pathbar.vala"
	_tmp2_ = self->priv->non_ghost_path;
#line 32 "../editor/short-pathbar.vala"
	if (g_strcmp0 (_tmp2_, "") != 0) {
#line 246 "short-pathbar.c"
		const gchar* _tmp3_;
#line 32 "../editor/short-pathbar.vala"
		_tmp3_ = self->priv->non_ghost_path;
#line 32 "../editor/short-pathbar.vala"
		_tmp1_ = model_utils_is_folder_path (_tmp3_);
#line 252 "short-pathbar.c"
	} else {
#line 32 "../editor/short-pathbar.vala"
		_tmp1_ = FALSE;
#line 256 "short-pathbar.c"
	}
#line 32 "../editor/short-pathbar.vala"
	if (_tmp1_) {
#line 260 "short-pathbar.c"
		const gchar* _tmp4_;
		const gchar* _tmp5_;
#line 32 "../editor/short-pathbar.vala"
		_tmp4_ = self->priv->complete_path;
#line 32 "../editor/short-pathbar.vala"
		_tmp5_ = self->priv->non_ghost_path;
#line 32 "../editor/short-pathbar.vala"
		_tmp0_ = g_str_has_prefix (_tmp4_, _tmp5_);
#line 269 "short-pathbar.c"
	} else {
#line 32 "../editor/short-pathbar.vala"
		_tmp0_ = FALSE;
#line 273 "short-pathbar.c"
	}
#line 32 "../editor/short-pathbar.vala"
	if (_tmp0_) {
#line 277 "short-pathbar.c"
		const gchar* _tmp6_;
		gchar* _tmp7_;
#line 33 "../editor/short-pathbar.vala"
		_tmp6_ = self->priv->non_ghost_path;
#line 33 "../editor/short-pathbar.vala"
		_tmp7_ = g_strdup (_tmp6_);
#line 33 "../editor/short-pathbar.vala"
		_g_free0 (_vala__fallback_path);
#line 33 "../editor/short-pathbar.vala"
		_vala__fallback_path = _tmp7_;
#line 288 "short-pathbar.c"
	} else {
		const gchar* _tmp8_;
		gchar* _tmp9_;
#line 35 "../editor/short-pathbar.vala"
		_tmp8_ = self->priv->complete_path;
#line 35 "../editor/short-pathbar.vala"
		_tmp9_ = g_strdup (_tmp8_);
#line 35 "../editor/short-pathbar.vala"
		_g_free0 (_vala__fallback_path);
#line 35 "../editor/short-pathbar.vala"
		_vala__fallback_path = _tmp9_;
#line 300 "short-pathbar.c"
	}
#line 37 "../editor/short-pathbar.vala"
	_tmp10_ = self->priv->complete_path;
#line 37 "../editor/short-pathbar.vala"
	_tmp11_ = g_strdup (_tmp10_);
#line 37 "../editor/short-pathbar.vala"
	_g_free0 (_vala__complete_path);
#line 37 "../editor/short-pathbar.vala"
	_vala__complete_path = _tmp11_;
#line 30 "../editor/short-pathbar.vala"
	if (_fallback_path) {
#line 30 "../editor/short-pathbar.vala"
		*_fallback_path = _vala__fallback_path;
#line 314 "short-pathbar.c"
	} else {
#line 30 "../editor/short-pathbar.vala"
		_g_free0 (_vala__fallback_path);
#line 318 "short-pathbar.c"
	}
#line 30 "../editor/short-pathbar.vala"
	if (_complete_path) {
#line 30 "../editor/short-pathbar.vala"
		*_complete_path = _vala__complete_path;
#line 324 "short-pathbar.c"
	} else {
#line 30 "../editor/short-pathbar.vala"
		_g_free0 (_vala__complete_path);
#line 328 "short-pathbar.c"
	}
}

ShortPathbar*
short_pathbar_construct (GType object_type,
                         const gchar* complete_path_or_empty,
                         ViewType type,
                         const gchar* path)
{
	ShortPathbar * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 43 "../editor/short-pathbar.vala"
	g_return_val_if_fail (complete_path_or_empty != NULL, NULL);
#line 43 "../editor/short-pathbar.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 43 "../editor/short-pathbar.vala"
	self = (ShortPathbar*) g_object_new (object_type, NULL);
#line 45 "../editor/short-pathbar.vala"
	_tmp0_ = g_strdup (complete_path_or_empty);
#line 45 "../editor/short-pathbar.vala"
	_g_free0 (self->priv->complete_path);
#line 45 "../editor/short-pathbar.vala"
	self->priv->complete_path = _tmp0_;
#line 46 "../editor/short-pathbar.vala"
	_tmp1_ = g_strdup (complete_path_or_empty);
#line 46 "../editor/short-pathbar.vala"
	_g_free0 (self->priv->non_ghost_path);
#line 46 "../editor/short-pathbar.vala"
	self->priv->non_ghost_path = _tmp1_;
#line 47 "../editor/short-pathbar.vala"
	pathbar_set_path ((Pathbar*) self, type, path);
#line 43 "../editor/short-pathbar.vala"
	return self;
#line 363 "short-pathbar.c"
}

ShortPathbar*
short_pathbar_new (const gchar* complete_path_or_empty,
                   ViewType type,
                   const gchar* path)
{
#line 43 "../editor/short-pathbar.vala"
	return short_pathbar_construct (TYPE_SHORT_PATHBAR, complete_path_or_empty, type, path);
#line 373 "short-pathbar.c"
}

static gboolean
short_pathbar_on_button_press_event (ShortPathbar* self,
                                     GtkWidget* widget,
                                     GdkEventButton* event)
{
	gboolean result;
#line 57 "../editor/short-pathbar.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 57 "../editor/short-pathbar.vala"
	g_return_val_if_fail (widget != NULL, FALSE);
#line 57 "../editor/short-pathbar.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 59 "../editor/short-pathbar.vala"
	self->priv->event_x = (gint) event->x;
#line 60 "../editor/short-pathbar.vala"
	result = FALSE;
#line 60 "../editor/short-pathbar.vala"
	return result;
#line 394 "short-pathbar.c"
}

static gboolean
_short_pathbar_on_button_press_event_gtk_widget_button_press_event (GtkWidget* _sender,
                                                                    GdkEventButton* event,
                                                                    gpointer self)
{
	gboolean result;
	result = short_pathbar_on_button_press_event ((ShortPathbar*) self, _sender, event);
#line 21 "../editor/short-pathbar.vala"
	return result;
#line 406 "short-pathbar.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 66 "../editor/short-pathbar.vala"
	return self ? g_object_ref (self) : NULL;
#line 414 "short-pathbar.c"
}

static void
short_pathbar_on_button_clicked (ShortPathbar* self,
                                 GtkButton* button)
{
	GtkMenuButton* menu_button = NULL;
	GtkMenuButton* _tmp0_;
	GtkPopover* popover = NULL;
	GtkPopover* _tmp1_;
	GtkPopover* _tmp2_;
	GtkAllocation allocation = {0};
	GtkAllocation _tmp3_ = {0};
	GdkRectangle rect = {0};
	GtkAllocation _tmp4_;
	GdkRectangle _tmp5_ = {0};
	GdkRectangle _tmp6_;
#line 64 "../editor/short-pathbar.vala"
	g_return_if_fail (self != NULL);
#line 64 "../editor/short-pathbar.vala"
	g_return_if_fail (button != NULL);
#line 66 "../editor/short-pathbar.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (button, gtk_menu_button_get_type (), GtkMenuButton));
#line 66 "../editor/short-pathbar.vala"
	menu_button = _tmp0_;
#line 67 "../editor/short-pathbar.vala"
	_tmp1_ = gtk_menu_button_get_popover (menu_button);
#line 67 "../editor/short-pathbar.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 67 "../editor/short-pathbar.vala"
	popover = _tmp2_;
#line 68 "../editor/short-pathbar.vala"
	if (popover == NULL) {
#line 69 "../editor/short-pathbar.vala"
		g_assert_not_reached ();
#line 450 "short-pathbar.c"
	}
#line 72 "../editor/short-pathbar.vala"
	gtk_widget_get_allocated_size ((GtkWidget*) menu_button, &_tmp3_, NULL);
#line 72 "../editor/short-pathbar.vala"
	allocation = _tmp3_;
#line 73 "../editor/short-pathbar.vala"
	_tmp4_ = allocation;
#line 73 "../editor/short-pathbar.vala"
	_tmp5_.x = self->priv->event_x;
#line 73 "../editor/short-pathbar.vala"
	_tmp5_.y = _tmp4_.height;
#line 73 "../editor/short-pathbar.vala"
	_tmp5_.width = 0;
#line 73 "../editor/short-pathbar.vala"
	_tmp5_.height = 0;
#line 73 "../editor/short-pathbar.vala"
	rect = _tmp5_;
#line 74 "../editor/short-pathbar.vala"
	_tmp6_ = rect;
#line 74 "../editor/short-pathbar.vala"
	gtk_popover_set_pointing_to (G_TYPE_CHECK_INSTANCE_CAST (popover, gtk_popover_get_type (), GtkPopover), &_tmp6_);
#line 64 "../editor/short-pathbar.vala"
	_g_object_unref0 (popover);
#line 64 "../editor/short-pathbar.vala"
	_g_object_unref0 (menu_button);
#line 476 "short-pathbar.c"
}

static void
_short_pathbar_on_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                     gpointer self)
{
#line 21 "../editor/short-pathbar.vala"
	short_pathbar_on_button_clicked ((ShortPathbar*) self, _sender);
#line 485 "short-pathbar.c"
}

static gboolean
short_pathbar_real_has_popover (Pathbar* base)
{
	ShortPathbar * self;
	GtkMenuButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean result;
#line 81 "../editor/short-pathbar.vala"
	self = (ShortPathbar*) base;
#line 83 "../editor/short-pathbar.vala"
	_tmp0_ = self->priv->menu_button;
#line 83 "../editor/short-pathbar.vala"
	_tmp1_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp0_);
#line 83 "../editor/short-pathbar.vala"
	_tmp2_ = _tmp1_;
#line 83 "../editor/short-pathbar.vala"
	result = _tmp2_;
#line 83 "../editor/short-pathbar.vala"
	return result;
#line 508 "short-pathbar.c"
}

static void
short_pathbar_real_close_menu (Pathbar* base)
{
	ShortPathbar * self;
	GtkMenuButton* _tmp0_;
#line 86 "../editor/short-pathbar.vala"
	self = (ShortPathbar*) base;
#line 88 "../editor/short-pathbar.vala"
	_tmp0_ = self->priv->menu_button;
#line 88 "../editor/short-pathbar.vala"
	gtk_toggle_button_set_active ((GtkToggleButton*) _tmp0_, FALSE);
#line 522 "short-pathbar.c"
}

static void
short_pathbar_real_toggle_menu (Pathbar* base)
{
	ShortPathbar * self;
	GtkMenuButton* _tmp0_;
	GtkMenuButton* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 91 "../editor/short-pathbar.vala"
	self = (ShortPathbar*) base;
#line 93 "../editor/short-pathbar.vala"
	_tmp0_ = self->priv->menu_button;
#line 93 "../editor/short-pathbar.vala"
	_tmp1_ = self->priv->menu_button;
#line 93 "../editor/short-pathbar.vala"
	_tmp2_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp1_);
#line 93 "../editor/short-pathbar.vala"
	_tmp3_ = _tmp2_;
#line 93 "../editor/short-pathbar.vala"
	gtk_toggle_button_set_active ((GtkToggleButton*) _tmp0_, !_tmp3_);
#line 545 "short-pathbar.c"
}

static void
short_pathbar_real_set_path (Pathbar* base,
                             ViewType type,
                             const gchar* path)
{
	ShortPathbar * self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	GtkLabel* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
#line 100 "../editor/short-pathbar.vala"
	self = (ShortPathbar*) base;
#line 100 "../editor/short-pathbar.vala"
	g_return_if_fail (path != NULL);
#line 102 "../editor/short-pathbar.vala"
	if (type == VIEW_TYPE_SEARCH) {
#line 103 "../editor/short-pathbar.vala"
		return;
#line 568 "short-pathbar.c"
	}
#line 105 "../editor/short-pathbar.vala"
	_tmp2_ = self->priv->complete_path;
#line 105 "../editor/short-pathbar.vala"
	if (g_strcmp0 (_tmp2_, "") == 0) {
#line 105 "../editor/short-pathbar.vala"
		_tmp1_ = TRUE;
#line 576 "short-pathbar.c"
	} else {
#line 106 "../editor/short-pathbar.vala"
		_tmp1_ = !g_str_has_suffix (path, "/");
#line 580 "short-pathbar.c"
	}
#line 105 "../editor/short-pathbar.vala"
	if (_tmp1_) {
#line 105 "../editor/short-pathbar.vala"
		_tmp0_ = TRUE;
#line 586 "short-pathbar.c"
	} else {
		const gchar* _tmp3_;
#line 107 "../editor/short-pathbar.vala"
		_tmp3_ = self->priv->complete_path;
#line 107 "../editor/short-pathbar.vala"
		_tmp0_ = !g_str_has_prefix (_tmp3_, path);
#line 593 "short-pathbar.c"
	}
#line 105 "../editor/short-pathbar.vala"
	if (_tmp0_) {
#line 597 "short-pathbar.c"
		gchar* _tmp4_;
		gchar* _tmp5_;
#line 109 "../editor/short-pathbar.vala"
		_tmp4_ = g_strdup (path);
#line 109 "../editor/short-pathbar.vala"
		_g_free0 (self->priv->complete_path);
#line 109 "../editor/short-pathbar.vala"
		self->priv->complete_path = _tmp4_;
#line 110 "../editor/short-pathbar.vala"
		_tmp5_ = g_strdup (path);
#line 110 "../editor/short-pathbar.vala"
		_g_free0 (self->priv->non_ghost_path);
#line 110 "../editor/short-pathbar.vala"
		self->priv->non_ghost_path = _tmp5_;
#line 612 "short-pathbar.c"
	}
#line 113 "../editor/short-pathbar.vala"
	_tmp6_ = self->priv->view_label;
#line 113 "../editor/short-pathbar.vala"
	_tmp7_ = model_utils_get_name (path);
#line 113 "../editor/short-pathbar.vala"
	_tmp8_ = _tmp7_;
#line 113 "../editor/short-pathbar.vala"
	gtk_label_set_text (_tmp6_, _tmp8_);
#line 113 "../editor/short-pathbar.vala"
	_g_free0 (_tmp8_);
#line 114 "../editor/short-pathbar.vala"
	short_pathbar_update_menu (self);
#line 626 "short-pathbar.c"
}

static void
short_pathbar_real_update_ghosts (Pathbar* base,
                                  const gchar* _non_ghost_path,
                                  gboolean is_search)
{
	ShortPathbar * self;
	gchar* _tmp0_;
#line 117 "../editor/short-pathbar.vala"
	self = (ShortPathbar*) base;
#line 117 "../editor/short-pathbar.vala"
	g_return_if_fail (_non_ghost_path != NULL);
#line 119 "../editor/short-pathbar.vala"
	_tmp0_ = g_strdup (_non_ghost_path);
#line 119 "../editor/short-pathbar.vala"
	_g_free0 (self->priv->non_ghost_path);
#line 119 "../editor/short-pathbar.vala"
	self->priv->non_ghost_path = _tmp0_;
#line 120 "../editor/short-pathbar.vala"
	short_pathbar_update_menu (self);
#line 648 "short-pathbar.c"
}

static void
short_pathbar_update_menu (ShortPathbar* self)
{
	GMenu* menu = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GMenu* _tmp2_ = NULL;
	GtkMenuButton* _tmp3_;
#line 127 "../editor/short-pathbar.vala"
	g_return_if_fail (self != NULL);
#line 130 "../editor/short-pathbar.vala"
	_tmp0_ = self->priv->complete_path;
#line 130 "../editor/short-pathbar.vala"
	_tmp1_ = self->priv->non_ghost_path;
#line 130 "../editor/short-pathbar.vala"
	_short_pathbar_update_menu (_tmp0_, _tmp1_, &_tmp2_);
#line 130 "../editor/short-pathbar.vala"
	_g_object_unref0 (menu);
#line 130 "../editor/short-pathbar.vala"
	menu = _tmp2_;
#line 131 "../editor/short-pathbar.vala"
	_tmp3_ = self->priv->menu_button;
#line 131 "../editor/short-pathbar.vala"
	gtk_menu_button_set_menu_model (_tmp3_, (GMenuModel*) menu);
#line 127 "../editor/short-pathbar.vala"
	_g_object_unref0 (menu);
#line 677 "short-pathbar.c"
}

static gchar**
_vala_array_dup14 (gchar** self,
                   gssize length)
{
#line 142 "../editor/short-pathbar.vala"
	if (length >= 0) {
#line 686 "short-pathbar.c"
		gchar** result;
		gssize i;
#line 142 "../editor/short-pathbar.vala"
		result = g_new0 (gchar*, length + 1);
#line 142 "../editor/short-pathbar.vala"
		for (i = 0; i < length; i++) {
#line 693 "short-pathbar.c"
			gchar* _tmp0_;
#line 142 "../editor/short-pathbar.vala"
			_tmp0_ = g_strdup (self[i]);
#line 142 "../editor/short-pathbar.vala"
			result[i] = _tmp0_;
#line 699 "short-pathbar.c"
		}
#line 142 "../editor/short-pathbar.vala"
		return result;
#line 703 "short-pathbar.c"
	}
#line 142 "../editor/short-pathbar.vala"
	return NULL;
#line 707 "short-pathbar.c"
}

static void
_short_pathbar_update_menu (const gchar* complete_path,
                            const gchar* non_ghost_path,
                            GMenu** menu)
{
	GMenu* _vala_menu = NULL;
	GMenu* _tmp0_;
	GMenu* section = NULL;
	GMenu* _tmp1_;
	gchar** split = NULL;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gint split_length1;
	gint _split_size_;
	gchar** _tmp4_;
	gint _tmp4__length1;
	gchar* last = NULL;
	gchar** _tmp5_;
	gint _tmp5__length1;
	gchar** _tmp6_;
	gint _tmp6__length1;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar** _tmp9_;
	gint _tmp9__length1;
	gchar** _tmp10_;
	gint _tmp10__length1;
	gchar** _tmp11_;
	gint _tmp11__length1;
	gchar* tmp_path = NULL;
	gchar* _tmp12_;
	gchar** _tmp14_;
	gint _tmp14__length1;
	const gchar* _tmp42_;
	GMenu* _tmp70_;
	const gchar* _tmp71_;
	GMenu* _tmp72_;
#line 133 "../editor/short-pathbar.vala"
	g_return_if_fail (complete_path != NULL);
#line 133 "../editor/short-pathbar.vala"
	g_return_if_fail (non_ghost_path != NULL);
#line 135 "../editor/short-pathbar.vala"
	_tmp0_ = g_menu_new ();
#line 135 "../editor/short-pathbar.vala"
	_g_object_unref0 (_vala_menu);
#line 135 "../editor/short-pathbar.vala"
	_vala_menu = _tmp0_;
#line 136 "../editor/short-pathbar.vala"
	_tmp1_ = g_menu_new ();
#line 136 "../editor/short-pathbar.vala"
	section = _tmp1_;
#line 138 "../editor/short-pathbar.vala"
	_tmp3_ = _tmp2_ = g_strsplit (complete_path, "/", 0);
#line 138 "../editor/short-pathbar.vala"
	split = _tmp3_;
#line 138 "../editor/short-pathbar.vala"
	split_length1 = _vala_array_length (_tmp2_);
#line 138 "../editor/short-pathbar.vala"
	_split_size_ = split_length1;
#line 139 "../editor/short-pathbar.vala"
	_tmp4_ = split;
#line 139 "../editor/short-pathbar.vala"
	_tmp4__length1 = split_length1;
#line 139 "../editor/short-pathbar.vala"
	if (_tmp4__length1 < 2) {
#line 140 "../editor/short-pathbar.vala"
		g_assert_not_reached ();
#line 777 "short-pathbar.c"
	}
#line 141 "../editor/short-pathbar.vala"
	_tmp5_ = split;
#line 141 "../editor/short-pathbar.vala"
	_tmp5__length1 = split_length1;
#line 141 "../editor/short-pathbar.vala"
	_tmp6_ = split;
#line 141 "../editor/short-pathbar.vala"
	_tmp6__length1 = split_length1;
#line 141 "../editor/short-pathbar.vala"
	_tmp7_ = _tmp5_[_tmp6__length1 - 1];
#line 141 "../editor/short-pathbar.vala"
	_tmp8_ = g_strdup (_tmp7_);
#line 141 "../editor/short-pathbar.vala"
	last = _tmp8_;
#line 142 "../editor/short-pathbar.vala"
	_tmp9_ = split;
#line 142 "../editor/short-pathbar.vala"
	_tmp9__length1 = split_length1;
#line 142 "../editor/short-pathbar.vala"
	_tmp10_ = split;
#line 142 "../editor/short-pathbar.vala"
	_tmp10__length1 = split_length1;
#line 142 "../editor/short-pathbar.vala"
	_tmp11_ = (_tmp9_ != NULL) ? _vala_array_dup14 (_tmp9_ + 1, (_tmp10__length1 - 1) - 1) : _tmp9_;
#line 142 "../editor/short-pathbar.vala"
	_tmp11__length1 = (_tmp10__length1 - 1) - 1;
#line 142 "../editor/short-pathbar.vala"
	split = (_vala_array_free (split, split_length1, (GDestroyNotify) g_free), NULL);
#line 142 "../editor/short-pathbar.vala"
	split = _tmp11_;
#line 142 "../editor/short-pathbar.vala"
	split_length1 = _tmp11__length1;
#line 142 "../editor/short-pathbar.vala"
	_split_size_ = split_length1;
#line 145 "../editor/short-pathbar.vala"
	_tmp12_ = g_strdup ("/");
#line 145 "../editor/short-pathbar.vala"
	tmp_path = _tmp12_;
#line 147 "../editor/short-pathbar.vala"
	if (g_strcmp0 (complete_path, "/") != 0) {
#line 819 "short-pathbar.c"
		GMenu* _tmp13_;
#line 148 "../editor/short-pathbar.vala"
		_tmp13_ = _vala_menu;
#line 148 "../editor/short-pathbar.vala"
		g_menu_append (_tmp13_, "/", "browser.open-path(('/',uint16 " MODEL_UTILS_folder_context_id_string "))");
#line 825 "short-pathbar.c"
	}
#line 151 "../editor/short-pathbar.vala"
	_tmp14_ = split;
#line 151 "../editor/short-pathbar.vala"
	_tmp14__length1 = split_length1;
#line 831 "short-pathbar.c"
	{
		gchar** item_collection = NULL;
		gint item_collection_length1 = 0;
		gint _item_collection_size_ = 0;
		gint item_it = 0;
#line 151 "../editor/short-pathbar.vala"
		item_collection = _tmp14_;
#line 151 "../editor/short-pathbar.vala"
		item_collection_length1 = _tmp14__length1;
#line 151 "../editor/short-pathbar.vala"
		for (item_it = 0; item_it < item_collection_length1; item_it = item_it + 1) {
#line 843 "short-pathbar.c"
			gchar* _tmp15_;
			gchar* item = NULL;
#line 151 "../editor/short-pathbar.vala"
			_tmp15_ = g_strdup (item_collection[item_it]);
#line 151 "../editor/short-pathbar.vala"
			item = _tmp15_;
#line 850 "short-pathbar.c"
			{
				const gchar* _tmp16_;
				const gchar* _tmp17_;
				gchar* _tmp18_;
				gchar* _tmp19_;
				gchar* _tmp20_;
				GVariant* variant = NULL;
				const gchar* _tmp21_;
				GVariant* _tmp22_;
				const gchar* _tmp23_;
#line 153 "../editor/short-pathbar.vala"
				_tmp16_ = tmp_path;
#line 153 "../editor/short-pathbar.vala"
				_tmp17_ = item;
#line 153 "../editor/short-pathbar.vala"
				_tmp18_ = g_strconcat (_tmp17_, "/", NULL);
#line 153 "../editor/short-pathbar.vala"
				_tmp19_ = _tmp18_;
#line 153 "../editor/short-pathbar.vala"
				_tmp20_ = g_strconcat (_tmp16_, _tmp19_, NULL);
#line 153 "../editor/short-pathbar.vala"
				_g_free0 (tmp_path);
#line 153 "../editor/short-pathbar.vala"
				tmp_path = _tmp20_;
#line 153 "../editor/short-pathbar.vala"
				_g_free0 (_tmp19_);
#line 154 "../editor/short-pathbar.vala"
				_tmp21_ = tmp_path;
#line 154 "../editor/short-pathbar.vala"
				_tmp22_ = g_variant_new ("(sq)", _tmp21_, MODEL_UTILS_folder_context_id, NULL);
#line 154 "../editor/short-pathbar.vala"
				g_variant_ref_sink (_tmp22_);
#line 154 "../editor/short-pathbar.vala"
				variant = _tmp22_;
#line 155 "../editor/short-pathbar.vala"
				_tmp23_ = tmp_path;
#line 155 "../editor/short-pathbar.vala"
				if (g_str_has_prefix (non_ghost_path, _tmp23_)) {
#line 889 "short-pathbar.c"
					GMenu* _tmp24_;
					const gchar* _tmp25_;
					GVariant* _tmp26_;
					gchar* _tmp27_;
					gchar* _tmp28_;
					gchar* _tmp29_;
					gchar* _tmp30_;
					gchar* _tmp31_;
					gchar* _tmp32_;
#line 156 "../editor/short-pathbar.vala"
					_tmp24_ = _vala_menu;
#line 156 "../editor/short-pathbar.vala"
					_tmp25_ = item;
#line 156 "../editor/short-pathbar.vala"
					_tmp26_ = variant;
#line 156 "../editor/short-pathbar.vala"
					_tmp27_ = g_variant_print (_tmp26_, TRUE);
#line 156 "../editor/short-pathbar.vala"
					_tmp28_ = _tmp27_;
#line 156 "../editor/short-pathbar.vala"
					_tmp29_ = g_strconcat ("browser.open-path(", _tmp28_, NULL);
#line 156 "../editor/short-pathbar.vala"
					_tmp30_ = _tmp29_;
#line 156 "../editor/short-pathbar.vala"
					_tmp31_ = g_strconcat (_tmp30_, ")", NULL);
#line 156 "../editor/short-pathbar.vala"
					_tmp32_ = _tmp31_;
#line 156 "../editor/short-pathbar.vala"
					g_menu_append (_tmp24_, _tmp25_, _tmp32_);
#line 156 "../editor/short-pathbar.vala"
					_g_free0 (_tmp32_);
#line 156 "../editor/short-pathbar.vala"
					_g_free0 (_tmp30_);
#line 156 "../editor/short-pathbar.vala"
					_g_free0 (_tmp28_);
#line 925 "short-pathbar.c"
				} else {
					GMenu* _tmp33_;
					const gchar* _tmp34_;
					GVariant* _tmp35_;
					gchar* _tmp36_;
					gchar* _tmp37_;
					gchar* _tmp38_;
					gchar* _tmp39_;
					gchar* _tmp40_;
					gchar* _tmp41_;
#line 158 "../editor/short-pathbar.vala"
					_tmp33_ = _vala_menu;
#line 158 "../editor/short-pathbar.vala"
					_tmp34_ = item;
#line 158 "../editor/short-pathbar.vala"
					_tmp35_ = variant;
#line 158 "../editor/short-pathbar.vala"
					_tmp36_ = g_variant_print (_tmp35_, TRUE);
#line 158 "../editor/short-pathbar.vala"
					_tmp37_ = _tmp36_;
#line 158 "../editor/short-pathbar.vala"
					_tmp38_ = g_strconcat ("browser.disabled-state-sq(", _tmp37_, NULL);
#line 158 "../editor/short-pathbar.vala"
					_tmp39_ = _tmp38_;
#line 158 "../editor/short-pathbar.vala"
					_tmp40_ = g_strconcat (_tmp39_, ")", NULL);
#line 158 "../editor/short-pathbar.vala"
					_tmp41_ = _tmp40_;
#line 158 "../editor/short-pathbar.vala"
					g_menu_append (_tmp33_, _tmp34_, _tmp41_);
#line 158 "../editor/short-pathbar.vala"
					_g_free0 (_tmp41_);
#line 158 "../editor/short-pathbar.vala"
					_g_free0 (_tmp39_);
#line 158 "../editor/short-pathbar.vala"
					_g_free0 (_tmp37_);
#line 962 "short-pathbar.c"
				}
#line 151 "../editor/short-pathbar.vala"
				_g_variant_unref0 (variant);
#line 151 "../editor/short-pathbar.vala"
				_g_free0 (item);
#line 968 "short-pathbar.c"
			}
		}
	}
#line 162 "../editor/short-pathbar.vala"
	_tmp42_ = last;
#line 162 "../editor/short-pathbar.vala"
	if (g_strcmp0 (_tmp42_, "") != 0) {
#line 976 "short-pathbar.c"
		gboolean is_folder = FALSE;
		const gchar* _tmp43_;
		const gchar* _tmp44_;
		gchar* _tmp45_;
		guint16 _tmp48_ = 0U;
		guint16 context_id = 0U;
		GVariant* variant = NULL;
		const gchar* _tmp49_;
		GVariant* _tmp50_;
		const gchar* _tmp51_;
#line 164 "../editor/short-pathbar.vala"
		is_folder = model_utils_is_folder_path (complete_path);
#line 165 "../editor/short-pathbar.vala"
		_tmp43_ = tmp_path;
#line 165 "../editor/short-pathbar.vala"
		_tmp44_ = last;
#line 165 "../editor/short-pathbar.vala"
		_tmp45_ = g_strconcat (_tmp43_, _tmp44_, NULL);
#line 165 "../editor/short-pathbar.vala"
		_g_free0 (tmp_path);
#line 165 "../editor/short-pathbar.vala"
		tmp_path = _tmp45_;
#line 166 "../editor/short-pathbar.vala"
		if (is_folder) {
#line 1001 "short-pathbar.c"
			const gchar* _tmp46_;
			gchar* _tmp47_;
#line 167 "../editor/short-pathbar.vala"
			_tmp46_ = tmp_path;
#line 167 "../editor/short-pathbar.vala"
			_tmp47_ = g_strconcat (_tmp46_, "/", NULL);
#line 167 "../editor/short-pathbar.vala"
			_g_free0 (tmp_path);
#line 167 "../editor/short-pathbar.vala"
			tmp_path = _tmp47_;
#line 1012 "short-pathbar.c"
		}
#line 169 "../editor/short-pathbar.vala"
		if (is_folder) {
#line 169 "../editor/short-pathbar.vala"
			_tmp48_ = MODEL_UTILS_folder_context_id;
#line 1018 "short-pathbar.c"
		} else {
#line 169 "../editor/short-pathbar.vala"
			_tmp48_ = MODEL_UTILS_undefined_context_id;
#line 1022 "short-pathbar.c"
		}
#line 169 "../editor/short-pathbar.vala"
		context_id = _tmp48_;
#line 170 "../editor/short-pathbar.vala"
		_tmp49_ = tmp_path;
#line 170 "../editor/short-pathbar.vala"
		_tmp50_ = g_variant_new ("(sq)", _tmp49_, context_id, NULL);
#line 170 "../editor/short-pathbar.vala"
		g_variant_ref_sink (_tmp50_);
#line 170 "../editor/short-pathbar.vala"
		variant = _tmp50_;
#line 171 "../editor/short-pathbar.vala"
		_tmp51_ = tmp_path;
#line 171 "../editor/short-pathbar.vala"
		if (g_str_has_prefix (non_ghost_path, _tmp51_)) {
#line 1038 "short-pathbar.c"
			GMenu* _tmp52_;
			const gchar* _tmp53_;
			GVariant* _tmp54_;
			gchar* _tmp55_;
			gchar* _tmp56_;
			gchar* _tmp57_;
			gchar* _tmp58_;
			gchar* _tmp59_;
			gchar* _tmp60_;
#line 172 "../editor/short-pathbar.vala"
			_tmp52_ = _vala_menu;
#line 172 "../editor/short-pathbar.vala"
			_tmp53_ = last;
#line 172 "../editor/short-pathbar.vala"
			_tmp54_ = variant;
#line 172 "../editor/short-pathbar.vala"
			_tmp55_ = g_variant_print (_tmp54_, TRUE);
#line 172 "../editor/short-pathbar.vala"
			_tmp56_ = _tmp55_;
#line 172 "../editor/short-pathbar.vala"
			_tmp57_ = g_strconcat ("browser.open-path(", _tmp56_, NULL);
#line 172 "../editor/short-pathbar.vala"
			_tmp58_ = _tmp57_;
#line 172 "../editor/short-pathbar.vala"
			_tmp59_ = g_strconcat (_tmp58_, ")", NULL);
#line 172 "../editor/short-pathbar.vala"
			_tmp60_ = _tmp59_;
#line 172 "../editor/short-pathbar.vala"
			g_menu_append (_tmp52_, _tmp53_, _tmp60_);
#line 172 "../editor/short-pathbar.vala"
			_g_free0 (_tmp60_);
#line 172 "../editor/short-pathbar.vala"
			_g_free0 (_tmp58_);
#line 172 "../editor/short-pathbar.vala"
			_g_free0 (_tmp56_);
#line 1074 "short-pathbar.c"
		} else {
			GMenu* _tmp61_;
			const gchar* _tmp62_;
			GVariant* _tmp63_;
			gchar* _tmp64_;
			gchar* _tmp65_;
			gchar* _tmp66_;
			gchar* _tmp67_;
			gchar* _tmp68_;
			gchar* _tmp69_;
#line 174 "../editor/short-pathbar.vala"
			_tmp61_ = _vala_menu;
#line 174 "../editor/short-pathbar.vala"
			_tmp62_ = last;
#line 174 "../editor/short-pathbar.vala"
			_tmp63_ = variant;
#line 174 "../editor/short-pathbar.vala"
			_tmp64_ = g_variant_print (_tmp63_, TRUE);
#line 174 "../editor/short-pathbar.vala"
			_tmp65_ = _tmp64_;
#line 174 "../editor/short-pathbar.vala"
			_tmp66_ = g_strconcat ("browser.disabled-state-sq(", _tmp65_, NULL);
#line 174 "../editor/short-pathbar.vala"
			_tmp67_ = _tmp66_;
#line 174 "../editor/short-pathbar.vala"
			_tmp68_ = g_strconcat (_tmp67_, ")", NULL);
#line 174 "../editor/short-pathbar.vala"
			_tmp69_ = _tmp68_;
#line 174 "../editor/short-pathbar.vala"
			g_menu_append (_tmp61_, _tmp62_, _tmp69_);
#line 174 "../editor/short-pathbar.vala"
			_g_free0 (_tmp69_);
#line 174 "../editor/short-pathbar.vala"
			_g_free0 (_tmp67_);
#line 174 "../editor/short-pathbar.vala"
			_g_free0 (_tmp65_);
#line 1111 "short-pathbar.c"
		}
#line 162 "../editor/short-pathbar.vala"
		_g_variant_unref0 (variant);
#line 1115 "short-pathbar.c"
	}
#line 177 "../editor/short-pathbar.vala"
	g_menu_freeze (section);
#line 178 "../editor/short-pathbar.vala"
	_tmp70_ = _vala_menu;
#line 178 "../editor/short-pathbar.vala"
	g_menu_append_section (_tmp70_, NULL, (GMenuModel*) section);
#line 180 "../editor/short-pathbar.vala"
	_tmp71_ = last;
#line 180 "../editor/short-pathbar.vala"
	pathbar_populate_pathbar_menu (g_strcmp0 (_tmp71_, "") == 0, &_vala_menu);
#line 182 "../editor/short-pathbar.vala"
	_tmp72_ = _vala_menu;
#line 182 "../editor/short-pathbar.vala"
	g_menu_freeze (_tmp72_);
#line 133 "../editor/short-pathbar.vala"
	_g_free0 (tmp_path);
#line 133 "../editor/short-pathbar.vala"
	_g_free0 (last);
#line 133 "../editor/short-pathbar.vala"
	split = (_vala_array_free (split, split_length1, (GDestroyNotify) g_free), NULL);
#line 133 "../editor/short-pathbar.vala"
	_g_object_unref0 (section);
#line 133 "../editor/short-pathbar.vala"
	if (menu) {
#line 133 "../editor/short-pathbar.vala"
		*menu = _vala_menu;
#line 1143 "short-pathbar.c"
	} else {
#line 133 "../editor/short-pathbar.vala"
		_g_object_unref0 (_vala_menu);
#line 1147 "short-pathbar.c"
	}
}

static void
short_pathbar_class_init (ShortPathbarClass * klass,
                          gpointer klass_data)
{
#line 21 "../editor/short-pathbar.vala"
	short_pathbar_parent_class = g_type_class_peek_parent (klass);
#line 21 "../editor/short-pathbar.vala"
	g_type_class_adjust_private_offset (klass, &ShortPathbar_private_offset);
#line 21 "../editor/short-pathbar.vala"
	G_OBJECT_CLASS (klass)->finalize = short_pathbar_finalize;
#line 21 "../editor/short-pathbar.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/ca/desrt/dconf-editor/ui/short-pathbar.ui");
#line 21 "../editor/short-pathbar.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "menu_button", FALSE, ShortPathbar_private_offset + G_STRUCT_OFFSET (ShortPathbarPrivate, menu_button));
#line 21 "../editor/short-pathbar.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "view_label", FALSE, ShortPathbar_private_offset + G_STRUCT_OFFSET (ShortPathbarPrivate, view_label));
#line 21 "../editor/short-pathbar.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_button_press_event", G_CALLBACK(_short_pathbar_on_button_press_event_gtk_widget_button_press_event));
#line 21 "../editor/short-pathbar.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_button_clicked", G_CALLBACK(_short_pathbar_on_button_clicked_gtk_button_clicked));
#line 1171 "short-pathbar.c"
}

static void
short_pathbar_pathbar_interface_init (PathbarIface * iface,
                                      gpointer iface_data)
{
#line 21 "../editor/short-pathbar.vala"
	short_pathbar_pathbar_parent_iface = g_type_interface_peek_parent (iface);
#line 21 "../editor/short-pathbar.vala"
	iface->get_complete_path = (void (*) (Pathbar*, gchar**)) short_pathbar_real_get_complete_path;
#line 21 "../editor/short-pathbar.vala"
	iface->get_fallback_path_and_complete_path = (void (*) (Pathbar*, gchar**, gchar**)) short_pathbar_real_get_fallback_path_and_complete_path;
#line 21 "../editor/short-pathbar.vala"
	iface->has_popover = (gboolean (*) (Pathbar*)) short_pathbar_real_has_popover;
#line 21 "../editor/short-pathbar.vala"
	iface->close_menu = (void (*) (Pathbar*)) short_pathbar_real_close_menu;
#line 21 "../editor/short-pathbar.vala"
	iface->toggle_menu = (void (*) (Pathbar*)) short_pathbar_real_toggle_menu;
#line 21 "../editor/short-pathbar.vala"
	iface->set_path = (void (*) (Pathbar*, ViewType, const gchar*)) short_pathbar_real_set_path;
#line 21 "../editor/short-pathbar.vala"
	iface->update_ghosts = (void (*) (Pathbar*, const gchar*, gboolean)) short_pathbar_real_update_ghosts;
#line 1194 "short-pathbar.c"
}

static void
short_pathbar_instance_init (ShortPathbar * self,
                             gpointer klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 21 "../editor/short-pathbar.vala"
	self->priv = short_pathbar_get_instance_private (self);
#line 23 "../editor/short-pathbar.vala"
	_tmp0_ = g_strdup ("");
#line 23 "../editor/short-pathbar.vala"
	self->priv->non_ghost_path = _tmp0_;
#line 25 "../editor/short-pathbar.vala"
	_tmp1_ = g_strdup ("");
#line 25 "../editor/short-pathbar.vala"
	self->priv->complete_path = _tmp1_;
#line 54 "../editor/short-pathbar.vala"
	self->priv->event_x = 0;
#line 21 "../editor/short-pathbar.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 1217 "short-pathbar.c"
}

static void
short_pathbar_finalize (GObject * obj)
{
	ShortPathbar * self;
#line 21 "../editor/short-pathbar.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SHORT_PATHBAR, ShortPathbar);
#line 23 "../editor/short-pathbar.vala"
	_g_free0 (self->priv->non_ghost_path);
#line 25 "../editor/short-pathbar.vala"
	_g_free0 (self->priv->complete_path);
#line 21 "../editor/short-pathbar.vala"
	G_OBJECT_CLASS (short_pathbar_parent_class)->finalize (obj);
#line 1232 "short-pathbar.c"
}

static GType
short_pathbar_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ShortPathbarClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) short_pathbar_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ShortPathbar), 0, (GInstanceInitFunc) short_pathbar_instance_init, NULL };
	static const GInterfaceInfo pathbar_info = { (GInterfaceInitFunc) short_pathbar_pathbar_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType short_pathbar_type_id;
	short_pathbar_type_id = g_type_register_static (gtk_grid_get_type (), "ShortPathbar", &g_define_type_info, 0);
	g_type_add_interface_static (short_pathbar_type_id, TYPE_PATHBAR, &pathbar_info);
	ShortPathbar_private_offset = g_type_add_instance_private (short_pathbar_type_id, sizeof (ShortPathbarPrivate));
	return short_pathbar_type_id;
}

GType
short_pathbar_get_type (void)
{
	static volatile gsize short_pathbar_type_id__once = 0;
	if (g_once_init_enter (&short_pathbar_type_id__once)) {
		GType short_pathbar_type_id;
		short_pathbar_type_id = short_pathbar_get_type_once ();
		g_once_init_leave (&short_pathbar_type_id__once, short_pathbar_type_id);
	}
	return short_pathbar_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

